<?xml version="1.0" ?>
<?xml-stylesheet href="report.xsl" type="text/xsl" ?>
<!--
    
    Role: format the outcome of TA processing so that the result is processable
    by the legacy WS-I report.xsl stylesheet, for HTML rendering.

    For more information on the Web Services Interoperability Organization, 
    please see http://www.ws-i.org/.

    @author Jacques Durand (Fujitsu)
    @version 0.9, 18/January/2009

    
  -->
<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:xsi="http://www.w3.org/2001/XMLSchema"
   xmlns:fn="http://www.w3.org/2005/xpath-functions" 
   xmlns:wsip="http://www.ws-i.org/2002/08/12/ProfileDoc-2.0.xsd"
   xmlns:wsi-log="http://www.ws-i.org/testing/2003/03/log/"
   xmlns:wsir="http://www.ws-i.org/testing/2009/03/report/" 
   xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/" 
   xmlns:wsil="http://www.ws-i.org/testing/2008/02/log/"
   version="2.0" >
  
  <xsl:output method="xml" indent="yes"/>

  <!-- xsl:variable name="testres" select="document('testresult.xml')"/ -->

  <xsl:template match="comment()"/>

  <xsl:template match="processing-instruction()">
  </xsl:template>


  <!-- ***************** process each artifact type *********************** -->

  <xsl:template mode="report" match="/">
    <xsl:param name="analyzerinfo"/>
    <xsl:param name="inputdoc"/>

    <xsl:variable name="msgentries" select="/wsit:results/wsit:test[@artifact = 'message']"/>
    <xsl:variable name="unique-msgentries" select="$msgentries[not(@id = preceding::*:test/@id)]"/>
    <xsl:variable name="dscentries" select="/wsit:results/wsit:test[@artifact = 'description']"/>
    <xsl:variable name="unique-dscentries" select="$dscentries[not(@id = preceding::wsit:test/@id)]"/>

    <!-- xsl:key name="tassertion_key" match="/wsit:results/wsit:test" use="/wsit:results/wsit:test/@id"/ -->

    <xsl:text disable-output-escaping="yes">&lt;?xml-stylesheet href="report.xsl" type="text/xsl" ?&gt;</xsl:text>
    <xsl:text>&#10;</xsl:text>

    <wsir:report 
       xmlns="http://www.ws-i.org/testing/2009/03/report/"
       xmlns:wsir="http://www.ws-i.org/testing/2009/03/report/"
       xmlns:wsil="http://www.ws-i.org/testing/2008/02/log/"
       xmlns:wsi-log="http://www.ws-i.org/testing/2003/03/log/"
       xmlns:wsi-analyzerConfig="http://www.ws-i.org/testing/2003/03/analyzerConfig/"
       xmlns:wsi-monConfig="http://www.ws-i.org/testing/2003/03/monitorConfig/"
       xmlns:wsi-assertions="http://www.ws-i.org/testing/2003/03/assertions/"
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
       xmlns:s="http://schemas.xmlsoap.org/soap/envelope/"
       xmlns:a="http://www.w3.org/2005/08/addressing"
       xsi:schemaLocation="http://www.ws-i.org/testing/2009/03/report/ wsi-report.xsd"
       name="WS-I Basic Profile Test Report. This report provides only an indication of conformance to the Profile. No formal conformance statement can be derived from it." >

<!-- Insert Analyzer Information -->
<wsir:analyzer>
  <wsir:profile>
    <wsir:name><xsl:value-of select="$analyzerinfo/*:profilename"/></wsir:name>
    <wsir:revision><xsl:value-of select="$analyzerinfo/*:profilerev"/></wsir:revision>
    <xsl:element name="wsir:implementer"> 
      <xsl:attribute name="name" namespace="" select="$analyzerinfo/*:profileimpname"/> 
      <xsl:attribute name="location" namespace="" select="$analyzerinfo/*:profileimplocn"/> 
    </xsl:element>
  </wsir:profile>
  <wsir:environment>
    <wsir:operatingSystem name="" version="" />
    <wsir:xmlParser name="" version="" />
  </wsir:environment>
  <wsir:analyzerEngine>
    <wsir:analyzerVersion><xsl:value-of select="$analyzerinfo/*:analyzervn"/></wsir:analyzerVersion>
    <wsir:releaseDate><xsl:value-of select="$analyzerinfo/*:analyzerdate"/></wsir:releaseDate>
    <xsl:element name="wsir:implementer"> 
      <xsl:attribute name="name" namespace="" select="$analyzerinfo/*:analyzerimpname"/> 
      <xsl:attribute name="location" namespace="" select="$analyzerinfo/*:profileimplocn"/> 
    </xsl:element>
    <wsir:xpathVersion>2.0</wsir:xpathVersion>
    <xsl:element name="wsir:xsltEngine"> 
      <xsl:attribute name="name" namespace="" select="$analyzerinfo/*:analyzergenxsltname"/> 
      <xsl:attribute name="version" namespace="" select="$analyzerinfo/*:analyzergenxsltvn"/> 
    </xsl:element>
    <wsir:generationTimestamp><xsl:value-of select="$analyzerinfo/*:analyzergentime"/></wsir:generationTimestamp>
  </wsir:analyzerEngine>
  <wsir:runConfig>
    <wsir:timestamp><xsl:value-of select="fn:current-dateTime()"/></wsir:timestamp>
    <xsl:element name="wsir:xsltEngine"> 
      <xsl:attribute name="name" namespace="" select="$analyzerinfo/*:runxsltname"/> 
      <xsl:attribute name="version" namespace="" select="$analyzerinfo/*:runxsltvn"/> 
    </xsl:element>
    <xsl:element name="wsir:docSource"> 
      <xsl:attribute name="timestamp" namespace="" select="$inputdoc/@timestamp"/> 
      <xsl:value-of select="$inputdoc"/>
    </xsl:element>
    <wsir:comments><xsl:value-of select="$analyzerinfo/*:runcomment"/></wsir:comments>
  </wsir:runConfig>
</wsir:analyzer>


      <!-- ***************  artifact:message **************** -->

      <xsl:call-template name="doartifact">
	<xsl:with-param name="artifact">message</xsl:with-param>
	<xsl:with-param name="entries" select="$unique-msgentries"/>
      </xsl:call-template>

      <xsl:call-template name="doartifact">
	<xsl:with-param name="artifact">description</xsl:with-param>
	<xsl:with-param name="entries" select="$unique-dscentries"/>
      </xsl:call-template>

      <!-- xsl:apply-templates select="self::node()/*"/ -->

    </wsir:report>

  </xsl:template>

  <!-- ***************** ************************* -->
  <!--  template all -->
  <xsl:template match="@*|node()"> 
  </xsl:template>

  <xsl:template mode="report" match="@*|node()"> 
  </xsl:template>

  <xsl:template name="doartifact"> 
    <xsl:param name="artifact"/>
    <xsl:param name="entries"/>

    <!-- ***************  generate report for 1 artifact **************** -->

    <wsir:artifact>
      <xsl:attribute name="type"><xsl:value-of select="$artifact"/></xsl:attribute>

      <xsl:for-each select="$entries"> 

	<xsl:variable name="logid" select="@id"/>

	<wsir:entry>
	  <xsl:attribute name="referenceID"><xsl:value-of select="$logid"/></xsl:attribute>

    	  <xsl:for-each select="/wsit:results/wsit:test[@id = $logid]">
	    <wsir:assertionResult>
	      <xsl:attribute name="id">
		<xsl:value-of select="@tassertion"/>
	      </xsl:attribute>

<!-- CHANGE ============================ -->
	      <xsl:if test="@prescription">
	      <xsl:attribute name="prescription">
		<xsl:value-of select="@prescription"/>
	      </xsl:attribute>
	      </xsl:if>

	      <xsl:attribute name="result">
		<xsl:value-of>
		  <xsl:choose>
		    <xsl:when test="@result = 'false'"><xsl:value-of select="wsir:reporting/@falsePredicateAs"/></xsl:when>
		    <xsl:when test="@result = 'true'"><xsl:value-of select="wsir:reporting/@truePredicateAs"/></xsl:when>
		    <!-- xsl:when test="@result = 'false'">failed</xsl:when>
		    <xsl:when test="@result = 'true'">passed</xsl:when -->
		    <xsl:when test="@result = 'notrelvt'">notRelevant</xsl:when>
		    <xsl:when test="@result = 'notappl'">notApplicable</xsl:when>
		    <xsl:when test="@result = 'misinput'">missingInput</xsl:when>
		    <xsl:otherwise>notApplicable</xsl:otherwise>
		  </xsl:choose>
		</xsl:value-of>
	      </xsl:attribute>

	      <!-- xsl:if test="@result = 'false'" -->
	      <xsl:if test="(@result = 'false' and wsir:reporting/@falsePredicateAs = 'failed') or (@result = 'false' and wsir:reporting/@falsePredicateAs = 'warning') or (@result = 'true' and wsir:reporting/@truePredicateAs = 'failed') or (@result = 'true' and wsir:reporting/@truePredicateAs = 'warning')">
		<wsir:failureMessage xml:lang="en">
		  <xsl:value-of select="wsit:errmessage"/>
		</wsir:failureMessage>
		<wsir:failureDetail xml:lang="en">
	<xsl:apply-templates mode="escapexml" select="./wsit:errdiagnostic/*"/>
		</wsir:failureDetail>
	      </xsl:if>
	      <!-- xsl:if test="@result = 'notrelvt'">
		<xsl:copy-of select="./*"/>
	      </xsl:if -->

	    </wsir:assertionResult>
	  </xsl:for-each> <!-- tassertion -->
	</wsir:entry>
      </xsl:for-each> <!-- unique-msgentries -->

    </wsir:artifact>

  </xsl:template>

<xsl:template mode="escapexml" match="node()">
  <xsl:choose>
    <xsl:when test="not(./*)">
    <xsl:value-of select="concat('&lt;', name(.))"/>
    <xsl:apply-templates mode="escapexmlatt" select="./@*"/>
    <xsl:value-of select="concat('&gt;', current())"/>
    <xsl:value-of select="concat('&lt;/', name(.), '&gt;&#10;')"/>
    </xsl:when>
    <xsl:otherwise>
    <xsl:value-of select="concat('&lt;', name(.))"/>
    <xsl:apply-templates mode="escapexmlatt" select="@*"/>
    <xsl:value-of select="concat('&gt;&#10;', '')"/>
    <!-- xsl:apply-templates mode="diag" select="node()"/ -->
    <xsl:apply-templates mode="escapexml" select="./element()"/>
    <xsl:value-of select="concat('&lt;/', name(.), '&gt;&#10;')"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template mode="escapexmlatt" match="@*">

    <xsl:value-of select="concat(' ', name(), '=&#34;', . , '&#34;')"/>

    <!-- xsl:apply-templates mode="diagatt" select="@*"/ -->

</xsl:template>


</xsl:stylesheet>



