<?xml version="1.0" encoding="UTF-8"?>

<!--
  Formatting for WS-I Profile Conformance Report generated by the Testing Tools
 
	Copyright (c) 2002-2010 by The Web Services-Interoperability Organization (WS-I) and 
	Certain of its Members. All Rights Reserved.
	
	Notice
	The material contained herein is not a license, either expressly or impliedly, to any 
	intellectual property owned or controlled by any of the authors or developers of this 
	material or WS-I. The material contained herein is provided on an "AS IS" basis and to 
	the maximum extent permitted by applicable law, this material is provided AS IS AND WITH 
	ALL FAULTS, and the authors and developers of this material and WS-I hereby disclaim all 
	other warranties and conditions, either express, implied or statutory, including, but not 
	limited to, any (if any) implied warranties, duties or conditions of  merchantability, 
	of fitness for a particular purpose, of accuracy or completeness of responses, of results, 
	of workmanlike effort, of lack of viruses, and of lack of negligence. ALSO, THERE IS NO 
	WARRANTY OR CONDITION OF TITLE, QUIET ENJOYMENT, QUIET POSSESSION, CORRESPONDENCE TO 
	DESCRIPTION OR NON-INFRINGEMENT WITH REGARD TO THIS MATERIAL.
	
	IN NO EVENT WILL ANY AUTHOR OR DEVELOPER OF THIS MATERIAL OR WS-I BE LIABLE TO ANY OTHER 
	PARTY FOR THE COST OF PROCURING SUBSTITUTE GOODS OR SERVICES, LOST PROFITS, LOSS OF USE, 
	LOSS OF DATA, OR ANY INCIDENTAL, CONSEQUENTIAL, DIRECT, INDIRECT, OR SPECIAL DAMAGES 
	WHETHER UNDER CONTRACT, TORT, WARRANTY, OR OTHERWISE, ARISING IN ANY WAY OUT OF THIS OR 
	ANY OTHER AGREEMENT RELATING TO THIS MATERIAL, WHETHER OR NOT SUCH PARTY HAD ADVANCE 
	NOTICE OF THE POSSIBILITY OF SUCH DAMAGES.
	
	WS-I License Information
	Use of this WS-I Material is governed by the WS-I Test License and other licenses.  Information on these 
	licenses are contained in the README.txt and ReleaseNotes.txt files.  By downloading this file, you agree 
	to the terms of these licenses.   

	How To Provide Feedback
	The Web Services-Interoperability Organization (WS-I) would like to receive input, 
	suggestions and other feedback ("Feedback") on this work from a wide variety of 
	industry participants to improve its quality over time. 
	
	By sending email, or otherwise communicating with WS-I, you (on behalf of yourself if 
	you are an individual, and your company if you are providing Feedback on behalf of the 
	company) will be deemed to have granted to WS-I, the members of WS-I, and other parties 
	that have access to your Feedback, a non-exclusive, non-transferable, worldwide, perpetual, 
	irrevocable, royalty-free license to use, disclose, copy, license, modify, sublicense or 
	otherwise distribute and exploit in any manner whatsoever the Feedback you provide regarding 
	the work. You acknowledge that you have no expectation of confidentiality with respect to 
	any Feedback you provide. You represent and warrant that you have rights to provide this 
	Feedback, and if you are providing Feedback on behalf of a company, you represent and warrant 
	that you have the rights to provide Feedback on behalf of your company. You also acknowledge 
	that WS-I is not required to review, discuss, use, consider or in any way incorporate your 
	Feedback into future versions of its work. If WS-I does incorporate some or all of your 
	Feedback in a future version of the work, it may, but is not obligated to include your name 
	(or, if you are identified as acting on behalf of your company, the name of your company) on 
	a list of contributors to the work. If the foregoing is not acceptable to you and any company 
	on whose behalf you are acting, please do not provide any Feedback.
	
	Feedback on this document should be directed to mailto:wsi_wsbasic_comment@mp.ws-i.org.


  Copyright (c) 2002-2010 IBM Corporation.  All rights reserved.

  @author Peter Brittenham, peterbr@us.ibm.com
  @version 1.0
  
-->

<xsl:stylesheet
   version="2.0"
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:wsi-common="http://www.ws-i.org/testing/2003/03/common/"
   xmlns:wsir="http://www.ws-i.org/testing/2009/03/report/"
   xmlns:wsi-profile="http://www.ws-i.org/2002/08/12/ProfileDoc-2.0.xsd"
   xmlns:wsitest="http://www.ws-i.org/testing/2007/03/test/"
   xmlns:wsi-analyzerConfig="http://www.ws-i.org/testing/2003/03/analyzerConfig/"
   xmlns:wsi-monConfig="http://www.ws-i.org/testing/2003/03/monitorConfig/"
   xmlns:xsd="http://www.w3.org/2001/XMLSchema"
   xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
   xmlns:wsrm="http://docs.oasis-open.org/ws-rx/wsrm/200702"
   xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
   xmlns:wsmc="http://docs.oasis-open.org/ws-rx/wsmc/200702"
   xmlns:wssc="http://docs.oasis-open.org/ws-sx/ws-secureconversation/200512"
   xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd"
   xmlns:wsa="http://www.w3.org/2005/08/addressing"
   xmlns:wsam="http://www.w3.org/2007/05/addressing/metadata"
   xmlns:wst="http://docs.oasis-open.org/ws-sx/ws-trust/200512"
   xmlns:unknown="http://dummy.examples.org/unknown/nmspace"
   xmlns:ds="http://www.w3.org/2000/09/xmldsig#"
   xmlns:wsse="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
   xmlns:wsi-log="http://www.ws-i.org/testing/2003/03/log/">
<xsl:import href="common.xsl"/>

<xsl:output method="html" indent="yes"/>
<xsl:preserve-space elements="wsir:analyzerFailure"/>
<xsl:strip-space elements="wsi-log:message wsi-log:httpHeaders" />

  <!-- FIX: Reference file on WS-I site when it is available. -->
<!-- xsl:variable name="tadURL" select="/wsir:report/wsir:analyzer/wsi-analyzerConfig:configuration/wsi-analyzerConfig:testAssertionsFile"/ -->
<xsl:variable name="tadURL">BP20-test.xml</xsl:variable>

<xsl:key name="id" match="@id" use="."/>
<xsl:key name="assertionID" match="wsir:entry/wsir:assertionResult" use="@id"/>

<xsl:template match="/">
<html>
	<!-- <link type="text/css" rel="stylesheet" href="http://www.ws-i.org/styles.css" /> -->
	<head>
    <title>WS-I Profile Conformance Report</title>
    <style type="text/css">
       BODY {
        border-top-style : none;
        border-left-style : none;
        border-right-style : none;
        border-bottom-style : none;
        font-family : Arial,sans-serif;
      }
      H1 {
        color : #336699;
      }
      H2 {
        background-color : #336699;
        PADDING-BOTTOM: 1px;
        PADDING-LEFT: 4px;
        PADDING-RIGHT: 4px;
        PADDING-TOP: 1px;
        color : white;
      }
      H3 {
        background-color : #7ca8da;
        padding-left : 6px;
        padding-right : 6px;
        padding-top : 2px;
        padding-bottom : 2px;
      }
      TABLE {
        margin-left : 1em;
        margin-right : 1em;
      }    
      .contents1 {
        margin-left : 2em;
      }
      .contents2 {
        margin-left : 2.2em;
      }
      .data-type {
        margin-left : 1em;
        margin-right : 1em;
      }    
      .data-content {
        margin-left : 1em;
        margin-right : 1em;
      }    
    </style>
	</head>

	<body>
    <a name="top"/>
    <img align="right" src="http://www.ws-i.org/images/WS-I-logo.gif"/>
    <h1>WS-I Profile Conformance Report</h1>
		<xsl:apply-templates />
	</body>
</html>
</xsl:template>

<xsl:template match="wsir:description" >
</xsl:template>

<xsl:template match="wsir:report" >
  <table>
  <tr><td>
  <b>Report:</b>
  </td><td>
  <xsl:value-of select="@name" />
  </td></tr>
  <!-- tr><td>
  <b>Date:</b>
	</td><td>
  <xsl:value-of select="@timestamp" />
	</td></tr -->
  </table>
  
  <xsl:call-template name="copyright"/>

  <p><xsl:value-of select="wsir:description" /></p>
  <hr style="color : black;"/>
  <xsl:apply-templates select="wsir:analyzer"/>
  <br/>
  <hr style="color : black;"/>
  <xsl:apply-templates select="wsir:summary"/>
  <br/>
  <hr style="color : black;"/>
  <br/>

  <a name="artifacts"><h2>Artifacts</h2></a>
  <ol>
  <xsl:for-each select="wsir:artifact">
    <xsl:variable name="linkName1" select="@type"/>
    <li><a href="#artifact-{$linkName1}"><xsl:value-of select="$linkName1"/></a></li>
  </xsl:for-each>
  </ol>
  
  <p/>
  <hr style="color : black;"/>
  <br/>
  
<!-- REMOVE:
  <h2>Assertion Entry List</h2>
  <ol>
  <xsl:for-each select="wsir:entry">
    <xsl:sort select="@referencI"/>
    <xsl:choose>
      <xsl:when test="@type='logEntry'">
        <xsl:variable name="linkName1" select="@type"/>
        <xsl:variable name="linkName2"  select="@logEntryID"/>
        <li><a href="#{$linkName1}{$linkName2}"><xsl:value-of select="$linkName1"/><xsl:text> </xsl:text><xsl:value-of select="$linkName2"/></a></li>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="linkName1" select="@type"/>
        <li><a href="#{$linkName1}"><xsl:value-of select="$linkName1"/></a></li>
      </xsl:otherwise>      
    </xsl:choose>
  </xsl:for-each>
  </ol>
  <hr style="color : black;"/>
  <xsl:apply-templates select="wsir:entry">
    <xsl:sort select="@logEntryID" data-type="number"/>
  </xsl:apply-templates>
-->
  <xsl:apply-templates select="wsir:artifact"/>
  <xsl:apply-templates select="wsir:analyzerFailure"/>
  
	<xsl:call-template name="notice"/>
</xsl:template>
  
<xsl:template match="wsir:analyzer" >
  <h2>Analyzer Tool Information</h2>
  <xsl:apply-templates />
</xsl:template>

<xsl:template match="wsir:profile" >
  <h3>Profile and Test Suite Information</h3>
  <table cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <tr bgcolor="#ffffff">
    <td>
      <b>Profile Name</b>
    </td>
    <td>
      <xsl:value-of select="wsir:name" />
    </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>Profile Revision</b>
    </td>
    <td>
      <xsl:value-of select="wsir:revision" />
    </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>Test Suite Implementer</b>
    </td>
    <td>
      <xsl:value-of select="wsir:implementer/@name" />
  </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>Implementer Location</b>
    </td>
    <td>
      <xsl:value-of select="wsir:implementer/@location" />
    </td>
  </tr>
  </table>
</xsl:template>
  
<xsl:template match="wsir:analyzerEngine" >
  <h3>Analyzer Engine Information</h3>
  <table cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <tr bgcolor="#ffffff">
    <td>
      <b>Analyzer Version</b>
    </td>
    <td>
      <xsl:value-of select="wsir:analyzerVersion" />
    </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>Release Date</b>
    </td>
    <td>
      <xsl:value-of select="wsir:releaseDate" />
    </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>Implementer</b>
    </td>
    <td>
      <xsl:value-of select="wsir:implementer/@name" />
    </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>Generation XSLT Engine</b>
    </td>
    <td>
      <xsl:value-of select="concat(wsir:xsltEngine/@name, ' ', wsir:xsltEngine/@version)" />
    </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>Generation Date</b>
    </td>
    <td>
      <xsl:value-of select="wsir:generationTimestamp" />
    </td>
  </tr>
  </table>
</xsl:template>  

<xsl:template match="wsir:runConfig" >
  <h3>Analyzer Run Time Details</h3>
  <table cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <tr bgcolor="#ffffff">
    <td>
      <b>Document Under test</b>
    </td>
    <td>
      <xsl:value-of select="wsir:docSource" />
    </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>Document Timestamp</b>
    </td>
    <td>
      <xsl:value-of select="wsir:docSource/@timestamp"/>
    </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>Time of Analysis</b>
    </td><td>
      <xsl:value-of select="wsir:timestamp" />
    </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>XSLT Engine used</b>
    </td>
    <td>
      <xsl:value-of select="concat(wsir:xsltEngine/@name, ' ', wsir:xsltEngine/@version)" />
    </td>
  </tr>
  <tr bgcolor="#ffffff">
    <td>
      <b>Comments</b>
    </td>
    <td>
      <xsl:value-of select="wsir:comments" />
    </td>
  </tr>
  </table>
</xsl:template>

<xsl:template match="wsir:summary" >
  <h2>Summary</h2>
  <table width="90%" cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <col span="1" width="20%"/>
  <tbody>
  <tr bgcolor="#ffffff"><td>
  <b>Result</b>
  </td>
  <xsl:choose>
    <xsl:when test="@result='failed'">
      <td style="color : {$failedColor};">
      <b><xsl:value-of select="@result" /></b>
      </td>
    </xsl:when>
    <xsl:otherwise>
      <td style="color : {$passedColor};">
      <b><xsl:value-of select="@result" /></b>
      </td>
    </xsl:otherwise>
  </xsl:choose>
  </tr>
  </tbody>
  </table>
  <br/>
  <p>
  <b>Artifact Targets Analyzed:</b>
  The summary result applies to the following artifact targets which were specified in the analyzer 
  configuration file.
  </p>
  <table width="90%" cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <col span="1" width="20%"/>
  <tbody>
  <xsl:if test="//wsi-analyzerConfig:uddiReference">
  <tr bgcolor="#ffffff">
  <td>
  <b>Discovery</b>
  </td>
	<td>
  <xsl:value-of select="//wsi-analyzerConfig:uddiReference/wsi-analyzerConfig:uddiKey/@type"/>
  <xsl:text>=</xsl:text>
  <xsl:value-of select="//wsi-analyzerConfig:uddiReference/wsi-analyzerConfig:uddiKey"/>  
	</td>
	</tr>  
	</xsl:if>
  <xsl:if test="//wsi-analyzerConfig:wsdlReference">
  <tr bgcolor="#ffffff">
  <td>
  <b>Description</b>
  </td>
	<td>
  <xsl:value-of select="//wsi-analyzerConfig:wsdlReference/wsi-analyzerConfig:wsdlElement/@type"/>
  <xsl:text>=</xsl:text>
  <xsl:value-of select="//wsi-analyzerConfig:wsdlReference/wsi-analyzerConfig:wsdlElement"/>  
	</td>
	</tr>  
	</xsl:if>
  <xsl:if test="//wsi-analyzerConfig:logFile">
  <tr bgcolor="#ffffff">
  <td>
  <b>Message</b>
  </td>
	<td>
  <xsl:value-of select="//wsi-analyzerConfig:logFile"/>
	</td>
	</tr>  
	</xsl:if>
  </tbody>
  </table>
  
  <xsl:apply-templates />
</xsl:template>

<xsl:template match="wsir:artifact" >
  <xsl:variable name="artifactType" select="@type"/>
  <h2><a name="artifact-{$artifactType}">Artifact: <xsl:value-of select="$artifactType"/></a></h2>
	<xsl:if test="wsir:artifactReference">
  <p>
  <b>Artifact Reference:</b>
  </p>
  <table cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <tr bgcolor="{$titleRowColor}"><td>
  <b>Timestamp</b>
  </td></tr>
  <tr bgcolor="#ffffff"><td>
  <xsl:value-of select="wsir:artifactReference/@timestamp" />
	</td></tr>
	<!-- ADD: Optional monitor comment
  <tr bgcolor="#ffffff"><td>
  <b>Monitor Config Comment</b>
	</td><td>
  <xsl:choose>
    <xsl:when test="wsir:log/wsi-monConfig:comment">    
      <xsl:value-of select="wsir:log/wsi-monConfig:comment" />
    </xsl:when>
    <xsl:otherwise>
      <xsl:text>[Not available in report]</xsl:text>
    </xsl:otherwise>
  </xsl:choose>
	</td></tr>
	-->
	</table>
	</xsl:if>

  <xsl:choose>
  <xsl:when test="wsir:entry">

  <p>
  <b>Assertion Result Summary:</b>
  </p>
  <table cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <tr bgcolor="{$titleRowColor}"><td>
  <b>Assertion ID</b> 
  </td><td>
<!-- CHANGE ============================ -->
  <b>Prescription</b> 
  </td><td>
  <b>Passed</b>
  </td><td>
  <b>Failed</b>
  </td><td>
  <b>Warning</b>
  </td><td>
  <b>Not Relevant</b>
  </td><td>
  <b>Missing Input</b>
  </td><td>
  <b>Not Applicable</b>
  </td></tr>
  <xsl:for-each select="wsir:entry/wsir:assertionResult/@id[generate-id() = generate-id(key('id', .))]">
  <xsl:sort select="." data-type="text"/>
	<!-- Get all of the summary result counts -->
<!-- CHANGE ============================ -->
  <xsl:variable name="prescriptionLevel">
    <xsl:value-of select="../@prescription"/>
  </xsl:variable>

  <xsl:variable name="passedCount">
  	<xsl:call-template name="getCount">
  		<xsl:with-param name="assertionID"><xsl:value-of select="current()"/></xsl:with-param>
  		<xsl:with-param name="result"><xsl:value-of select="'passed'"/></xsl:with-param>
  	</xsl:call-template>
  </xsl:variable>
  <xsl:variable name="failedCount">
  	<xsl:call-template name="getCount">
  		<xsl:with-param name="assertionID"><xsl:value-of select="current()"/></xsl:with-param>
  		<xsl:with-param name="result"><xsl:value-of select="'failed'"/></xsl:with-param>
  	</xsl:call-template>
  </xsl:variable>
  <xsl:variable name="warningCount">
  	<xsl:call-template name="getCount">
  		<xsl:with-param name="assertionID"><xsl:value-of select="current()"/></xsl:with-param>
  		<xsl:with-param name="result"><xsl:value-of select="'warning'"/></xsl:with-param>
  	</xsl:call-template>
  </xsl:variable>
  <xsl:variable name="nrCount">
  	<xsl:call-template name="getCount">
  		<xsl:with-param name="assertionID"><xsl:value-of select="current()"/></xsl:with-param>
  		<xsl:with-param name="result"><xsl:value-of select="'notRelevant'"/></xsl:with-param>
  	</xsl:call-template>
  </xsl:variable>
  <xsl:variable name="naCount"><xsl:text> </xsl:text>
  	<!-- xsl:call-template name="getCount">
  		<xsl:with-param name="assertionID"><xsl:value-of select="current()"/></xsl:with-param>
  		<xsl:with-param name="result"><xsl:value-of select="'notApplicable'"/></xsl:with-param>
  	</xsl:call-template -->
  </xsl:variable>
  <xsl:variable name="miCount">
  	<xsl:call-template name="getCount">
  		<xsl:with-param name="assertionID"><xsl:value-of select="current()"/></xsl:with-param>
  		<xsl:with-param name="result"><xsl:value-of select="'missingInput'"/></xsl:with-param>
  	</xsl:call-template>
  </xsl:variable>

  <tr bgcolor="#ffffff">
  <td>
  <xsl:choose>
  <xsl:when test="$failedCount > 0">
    <b style="color : {$failedColor};"><xsl:value-of select="current()" /></b>
  </xsl:when>
  <xsl:when test="$warningCount > 0">
    <b style="color : {$warningColor}"><xsl:value-of select="current()" /></b>
  </xsl:when>
  <xsl:when test="$passedCount > 0">
    <b style="color : {$passedColor}"><xsl:value-of select="current()" /></b>
  </xsl:when>
  <xsl:when test="$nrCount > 0">
    <b style="color : {$notRelevantColor}"><xsl:value-of select="current()" /></b>
  </xsl:when>
  <xsl:when test="$miCount > 0">
    <b style="color : {$missingInputColor}"><xsl:value-of select="current()" /></b>
  </xsl:when>
  <xsl:otherwise>
	  <b style="color : {$notApplicableColor}"><xsl:value-of select="current()" /></b>
	</xsl:otherwise>
	</xsl:choose>
	<!-- Is this needed?
  [<a href="{$tadURL}{current()}">Description</a>]
  -->
  </td>

<!-- CHANGE ============================ -->
  <xsl:choose>
  <xsl:when test="$prescriptionLevel = 'mandatory'">
    <td style="color : black;">mandatory</td>
  </xsl:when>
  <xsl:when test="$prescriptionLevel = 'preferred'">
    <td>preferred</td>
  </xsl:when>
  <xsl:when test="$prescriptionLevel = 'permitted'">
    <td>permitted</td>
  </xsl:when>
  <xsl:when test="$prescriptionLevel = 'optional'">
    <td>permitted</td>
  </xsl:when>
  <xsl:otherwise>
	  <td>
	  <xsl:value-of select="'undetermined'"/>
	  </td>
	</xsl:otherwise>
	</xsl:choose>

  <xsl:choose>
  <xsl:when test="$passedCount > 0">
    <td style="color : {$passedColor};">
    <b><xsl:value-of select="$passedCount" /></b>
    </td>
  </xsl:when>
  <xsl:otherwise>
	  <td>
	  <xsl:value-of select="$passedCount"/>
	  </td>
	</xsl:otherwise>
	</xsl:choose>

  <xsl:choose>
  <xsl:when test="$failedCount > 0">
    <td style="color : {$failedColor};">
    <b><xsl:value-of select="$failedCount" /></b>
    </td>
  </xsl:when>
  <xsl:otherwise>
	  <td>
	  <xsl:value-of select="$failedCount"/>
	  </td>
	</xsl:otherwise>
	</xsl:choose>

  <xsl:choose>
  <xsl:when test="$warningCount > 0">
    <td style="color : {$warningColor};">
    <b><xsl:value-of select="$warningCount" /></b>
    </td>
  </xsl:when>
  <xsl:otherwise>
	  <td>
	  <xsl:value-of select="$warningCount"/>
	  </td>
	</xsl:otherwise>
	</xsl:choose>

  <xsl:choose>
  <xsl:when test="$nrCount > 0">
    <td style="color : {$notRelevantColor};">
    <b><xsl:value-of select="$nrCount" /></b>
    </td>
  </xsl:when>
  <xsl:otherwise>
	  <td>
	  <xsl:value-of select="$nrCount"/>
	  </td>
	</xsl:otherwise>
  </xsl:choose>

  <xsl:choose>
    <xsl:when test="$miCount > 0">
    <td style="color : {$missingInputColor};">
    <b><xsl:value-of select="$miCount" /></b>
    <!-- b><xsl:text>X</xsl:text></b -->
    </td>
    </xsl:when>
    <xsl:otherwise>
	  <td>
	  </td>
    </xsl:otherwise>
  </xsl:choose>

  <xsl:choose>
  <xsl:when test="$naCount > 0">
    <td style="color : {$notApplicableColor};">
    <b><xsl:text>X</xsl:text></b>
    <!-- b><xsl:value-of select="$naCount" /></b -->
    </td>
  </xsl:when>
  <xsl:otherwise>
	  <td>
	  <xsl:value-of select="$naCount"/>
	  </td>
	</xsl:otherwise>
  </xsl:choose>

  </tr>
  </xsl:for-each>
  </table>
  
  <xsl:if test="wsir:entry/@type!=''">
  <p>
  <b>Entry List:</b>
  </p>
  <table cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <tr bgcolor="{$titleRowColor}"><td>
  <b>Reference ID</b>
  </td><td>
  <b>Type</b>
  </td></tr>
  <!-- ADD: Set sort data type based on artifact type
  <xsl:choose>
    <xsl:when test="$typeName='message'">
      <xsl:variable name="dataType" select="'number'"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:variable name="dataType" select="'text'"/>
    </xsl:otherwise>      
  </xsl:choose>
  -->
  <xsl:for-each select="wsir:entry">
    <!--<xsl:sort select="@referenceID" data-type="number"/>-->
    <tr bgcolor="#ffffff"><td>
    <xsl:variable name="referenceID" select="@referenceID"/>
    <xsl:choose>
      <xsl:when test="@referenceID">
        <a href="#entry-{$referenceID}"><xsl:value-of select="$referenceID"/></a>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>[Not specified]</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    </td><td>
    <xsl:value-of select="@type"/>
    </td>
    </tr>
  </xsl:for-each>
  </table>
  </xsl:if>
  
  <p><a href="#artifacts">Return to list of artifacts.</a></p>
  <p/>
	
  <hr style="color : black;"/>
  <xsl:apply-templates select="wsir:entry">
    <!--<xsl:sort select="@referenceID" data-type="number"/>-->
  </xsl:apply-templates>
  </xsl:when>
  <xsl:otherwise>
  <p><b>This artifact was not processed by the analyzer.</b></p>
  <p><a href="#artifacts">Return to list of artifacts.</a></p>
  <p/>
  </xsl:otherwise>
  </xsl:choose>
  <hr style="color : black;"/>
</xsl:template>

<xsl:template name="getCount">
	<xsl:param name="assertionID"/>
	<xsl:param name="result"/>
	<xsl:value-of select="count(key('assertionID', $assertionID)[@result = $result])"/>
</xsl:template>

<xsl:template match="wsir:entry" >
  <h3>
  <xsl:choose>
  <xsl:when test="@referenceID">
    <xsl:variable name="linkName" select="@referenceID"/>
    <a name="entry-{$linkName}">Entry: <xsl:value-of select="$linkName"/></a>
  </xsl:when>
  <xsl:otherwise>
    <xsl:variable name="linkName" select="@type"/>
    <a name="entry-{$linkName}">Entry: <xsl:value-of select="$linkName"/></a>
  </xsl:otherwise>
  </xsl:choose>
  </h3>

  <xsl:if test="wsir:entry/@type!=''">
  <table cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <tr bgcolor="{$titleRowColor}"><td>
  <b>Reference ID</b>
	</td><td>
  <b>Type</b>
	</td></tr>
  <tr bgcolor="#ffffff"><td>
  <xsl:value-of select="@referenceID" />
	</td><td>
  <xsl:value-of select="@type" />
	</td></tr>
  </table>
	</xsl:if>

  <p/>
  <xsl:choose>
  <xsl:when test="wsir:assertionResult">
	  <xsl:apply-templates />
	</xsl:when>
	<xsl:otherwise>
		<b>NOTE: There were no test assertion results for this entry.</b>
	</xsl:otherwise>
	</xsl:choose>
  <p><a href="#artifacts">Return to list of artifacts.</a></p>
  <p/>
</xsl:template>

<xsl:template match="wsi-log:messageEntry">
  <h4>Message Entry:</h4>
    <table width="90%" cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
    <tr bgcolor="#ffffff"><td>
    <b>Type</b>
	  </td><td>
    <xsl:value-of select="@type" />
  	</td></tr>
    <tr bgcolor="#ffffff"><td>
    <b>Conversation ID</b>
	  </td><td>
    <xsl:value-of select="@conversationID" />
  	</td></tr>
    <tr bgcolor="#ffffff"><td>
    <b>Sender Host and Port</b>
	  </td><td>
    <xsl:value-of select="wsi-log:senderHostAndPort" />
  	</td></tr>
    <tr bgcolor="#ffffff"><td>
    <b>Receiver Host and Port</b>
	  </td><td>
    <xsl:value-of select="wsi-log:receiverHostAndPort" />
  	</td></tr>
    <tr bgcolor="#ffffff"><td>
    <b>HTTP Headers</b>
	  </td><td>
    <pre><xsl:value-of select="wsi-log:httpHeaders" /></pre>
  	</td></tr>
    <tr bgcolor="#ffffff"><td>
    <b>Message</b>
	  </td><td>
    <xsl:variable name="messageContent" select="wsi-log:messageContent"/>
    <xsl:choose>
    <xsl:when test="contains($messageContent, '&#xD;')">
    <pre><xsl:value-of select="wsi-log:messageContent" /></pre>
    </xsl:when>
    <xsl:when test="contains($messageContent, '&#xA;')">
    <pre><xsl:value-of select="wsi-log:messageContent" /></pre>
    </xsl:when>
    <xsl:otherwise>
    <text><xsl:value-of select="wsi-log:messageContent" /></text>
    </xsl:otherwise>
    </xsl:choose>
  	</td></tr>
    </table>
</xsl:template>

<xsl:template match="wsir:assertionResult" >
  <xsl:variable name="linkName" select="@id"/>
  <!-- FIX: Reference file on WS-I site when it is available. -->
	<a name="#{$linkName}"></a><h4>Assertion: <a href="{$tadURL}#{$linkName}">
	<xsl:value-of select="$linkName"/>
	</a></h4>
  <table width="90%" cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <col span="1" width="20%"/>
  <tbody>
  <tr bgcolor="#ffffff"><td>
  <b>Result</b>
  </td>
  <xsl:choose>
    <xsl:when test="@result='failed'">
      <td style="color : {$failedColor};">
      <b><xsl:value-of select="@result" /></b>
      </td>
    </xsl:when>    
    <xsl:when test="@result='passed'">
      <td style="color : {$passedColor};">
      <b><xsl:value-of select="@result" /></b>
      </td>
    </xsl:when>
    <xsl:when test="@result='warning'">
      <td style="color : {$warningColor};">
      <b><xsl:value-of select="@result" /></b>
      </td>
    </xsl:when>
    <xsl:when test="@result='notRelevant'">
      <td style="color : {$notRelevantColor};">
      <b><xsl:value-of select="@result" /></b>
      </td>
    </xsl:when>
    <xsl:when test="@result='missingInput'">
      <td style="color : {$missingInputColor};">
      <b><xsl:value-of select="@result" /></b>
      </td>
    </xsl:when>
    <xsl:otherwise>
      <td style="color : {$notApplicableColor};">
      <b><xsl:value-of select="@result" /></b>
      </td>
    </xsl:otherwise>
  </xsl:choose>
  </tr>
  <xsl:if test="wsir:assertionDescription">
    <tr bgcolor="#ffffff"><td>
    <b>Assertion Description</b>
    </td><td>
    <xsl:value-of select="wsir:assertionDescription" />
    </td></tr>
  </xsl:if>
  <xsl:if test="wsir:failureMessage">
    <tr bgcolor="#ffffff"><td>
    <b>Failure Message</b>
    </td><td>
    <xsl:value-of select="wsir:failureMessage" />
    </td></tr>
  </xsl:if>
  <xsl:for-each select="wsir:failureDetail">
    <tr bgcolor="#ffffff"><td>
    <b>Failure Detail Message</b>
    </td><td>
	<pre>
	<xsl:copy-of select="."/>
	</pre>
    </td></tr>
  </xsl:for-each>
  <xsl:if test="wsir:prereqFailedList">
    <tr bgcolor="#ffffff">
    <td>
		<b>Prereq Failed List</b>
    </td>
    <td style="color : {$warningColor};">
		<xsl:for-each select="wsir:prereqFailedList/wsir:testAssertionID">
			<b>
			<text>
				<xsl:value-of select="." />
			</text>
			</b>
		</xsl:for-each>
    </td></tr>
  </xsl:if>
  <xsl:for-each select="wsir:additionalEntryType">
    <tr bgcolor="#ffffff"><td>
    <b>Additional Entry Type</b>
    </td><td>
      <xsl:value-of select="@type" />
  	</td></tr>
  </xsl:for-each>
  </tbody>
  </table>
  <p/>
</xsl:template>

<xsl:template match="wsir:analyzerFailure" >
  <hr style="color : black;"/>
  <h2 style="background-color: red;">Analyzer Failure</h2>
  
  <xsl:if test="wsir:failureDetail">
  <table width="90%" cellpadding="4" bgcolor="#000000" cellspacing="1" valign="top">
  <col span="1" width="20%"/>
  <tbody>
    <xsl:for-each select="wsir:failureDetail">
    <tr bgcolor="#ffffff"><td>
    <b>Failure Detail Message</b>
    </td><td>
    <pre>
    <!-- CHANGE: xsl:value-of select="current()"/ -->
    <xsl:copy-of select="current()"/>
    </pre>
    </td></tr>
  </xsl:for-each>
  </tbody>
  </table>
  </xsl:if>
  <hr style="color : black;"/>
</xsl:template>

<xsl:template mode="diag" match="node()">
  <xsl:choose>
    <xsl:when test="text()">
    <br/><xsl:value-of select="concat('&lt;', name(.))"/>
    <xsl:apply-templates mode="diagatt" select="@*"/>
    <xsl:value-of select="concat('&gt;', current())"/>
    <xsl:value-of select="concat('&lt;/', name(.), '&gt;')"/>
    </xsl:when>
    <xsl:otherwise>
    <br/><xsl:value-of select="concat('&lt;', name(.))"/>
    <xsl:apply-templates mode="diagatt" select="@*"/>
    <xsl:value-of select="concat('&gt;', '')"/>
    <xsl:apply-templates mode="diag" select="node()"/>
    <br/><xsl:value-of select="concat('&lt;/', name(.), '&gt;')"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template mode="diagatt" match="@*">

    <xsl:value-of select="concat(' ', name(), '=&#34;', . , '&#34;')"/>

    <!-- xsl:apply-templates mode="diagatt" select="@*"/ -->

</xsl:template>


</xsl:stylesheet>

