<?xml version="1.0" encoding="UTF-8"?>

<?xml-stylesheet type="text/xsl" ?>


<xsl:stylesheet version="2.0" 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns="http://www.ws-i.org/testing/2007/03/test/" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" 
xmlns:soap11="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:soap12="http://www.w3.org/2003/05/soap-envelope" 
xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" 
xmlns:xenc="http://www.w3.org/2001/04/xmlenc#" 
xmlns:wsoap12="http://schemas.xmlsoap.org/wsdl/soap12/" 
xmlns:wsoap11="http://schemas.xmlsoap.org/wsdl/soap/" 
xmlns:soapbind="http://schemas.xmlsoap.org/wsdl/soap/" 
xmlns:wsil="http://www.ws-i.org/testing/2008/02/log/" 
xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/" 
xmlns:fn="http://www.w3.org/2005/xpath-functions" 
xmlns:wsa="http://www.w3.org/2005/08/addressing" 
xmlns:wsam="http://www.w3.org/2007/05/addressing/metadata" 
xmlns:ds="http://www.w3.org/2000/09/xmldsig#" 
xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd" 
xmlns:wsse="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd" 
xmlns:wssc="http://docs.oasis-open.org/ws-sx/ws-secureconversation/200512" 
xmlns:wsmc="http://docs.oasis-open.org/ws-rx/wsmc/200702" 
xmlns:wst="http://docs.oasis-open.org/ws-sx/ws-trust/200512" 
xmlns:wsrm="http://docs.oasis-open.org/ws-rx/wsrm/200702" >


<xsl:output xmlns:xsl="http://www.w3.org/1999/XSL/Transform" method="xml" indent="yes"/>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" name="getAnalyzerInfo">
   <wsit:profilename xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/">Basic Profile Version 2.0</wsit:profilename>
   <wsit:profilerev xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/">$Revision: 1.114 $</wsit:profilerev>
   <wsit:profileimpname xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/">Web Services Interoperability Org. (Basic Profile WG)</wsit:profileimpname>
   <wsit:profileimplocn xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/">http://www.ws-i.org</wsit:profileimplocn>
   <wsit:analyzervn xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/">V2.0</wsit:analyzervn>
   <wsit:analyzerdate xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/">2009-09-10</wsit:analyzerdate>
   <wsit:analyzerimpname xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/">Web Services Interoperability Organization</wsit:analyzerimpname>
   <wsit:analyzerimplocn xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/">http://www.ws-i.org</wsit:analyzerimplocn>
   <wsit:analyzergentime xmlns:wsit="http://www.ws-i.org/testing/2007/03/test/">2010-11-05T11:06:17.51-07:00</wsit:analyzergentime>
   <analyzergenxsltname>Saxon B</analyzergenxsltname>
   <analyzergenxsltvn>V0.9</analyzergenxsltvn>
   <!--Set with the XSLT engine used to run this Analyzer script:-->
<runxsltname>Saxon B</runxsltname>
   <!--Set with comments to appear in test reports produced with this Analyzer:-->
<runcomment>no comments</runcomment>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope[soap12:Header[some $hbloc in child::* satisfies not(fn:namespace-uri($hbloc) = 'http://www.w3.org/2005/08/addressing') and not($hbloc/attribute::*:IsReferenceParameter) ]]"
              priority="151901">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">permitted</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1901&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1901&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1901</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="fn:true()">
                     <xsl:attribute name="result">true</xsl:attribute>
                     <xsl:element name="errmessage">
        Extensibility Point WARNING: The soap12:Envelope makes use of extra SOAP headers
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Extensibility Point WARNING: The soap12:Envelope makes use of extra SOAP headers
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="warning"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope[.//attribute::*:role]"
              priority="151904">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">permitted</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1904&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1904&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1904</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="every $rval in .//*/attribute::*:role satisfies ($rval = 'http://www.w3.org/2003/05/soap-envelope/role/next' or $rval = 'http://www.w3.org/2003/05/soap-envelope/role/none')">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Extensibility Point WARNING: The soap12:Envelope contains @role with unspecified values
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope[soap12:Body/soap12:Fault/soap12:Detail]"
              priority="151905">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">permitted</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1905&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1905&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1905</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="fn:true()">
                     <xsl:attribute name="result">true</xsl:attribute>
                     <xsl:element name="errmessage">
        Extensibility Point WARNING: The soap12:Fault makes use of optional Detail element
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Extensibility Point WARNING: The soap12:Fault makes use of optional Detail element
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="warning"
                                  falsePredicateAs="passed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents[@containsXmlDecl = 'true']/soap12:Envelope"
              priority="151015">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1015&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1015&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1015</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not (/wsil:testLog/wsil:messageLog/wsil:message[(@type = 'response' and @conversation = $mytarget/../../@conversation) or (.//soap12:Envelope/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] =  $mytarget/soap12:Header/wsa:MessageID)]/wsil:messageContents/soap12:Envelope/soap12:Body/soap12:Fault )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A soap Fault has been generated when receiving a message with an XML declaration: 
        verify that this Fault has another cause - it must not be caused by the XML declaration.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents[fn:starts-with(fn:lower-case(@encoding), 'utf-8') ]/soap12:Envelope[soap12:Header/*:R1019 or soap12:Header/*:R4006]"
              priority="151306">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1306&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1306&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1306</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not (/wsil:testLog/wsil:messageLog/wsil:message[(@type = 'response' and @conversation = $mytarget/../../@conversation) or (.//soap12:Envelope/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] =  $mytarget/soap12:Header/wsa:MessageID)]/wsil:messageContents/soap12:Envelope/soap12:Body/soap12:Fault )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A SOAP Fault has been generated when receiving a message with  a UTF-8 Unicode Byte Order Mark. Please verify that this fault has another cause - it must not be caused by the presence of the B.O.M.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents[fn:starts-with(fn:lower-case(@encoding), 'utf-16') ]/soap12:Envelope[soap12:Header/*:R4007]"
              priority="151307">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1307&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1307&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1307</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not (/wsil:testLog/wsil:messageLog/wsil:message[(@type = 'response' and @conversation = $mytarget/../../@conversation) or (.//soap12:Envelope/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] =  $mytarget/soap12:Header/wsa:MessageID)]/wsil:messageContents/soap12:Envelope/soap12:Body/soap12:Fault )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A soap Fault has been generated when receiving a message with  a UTF-16 Unicode Byte Order Mark. Please verify that this Fault has another cause - it must not be caused by the presence of the B.O.M.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope"
              priority="151019">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1019&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1019&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_metadata"
                    select="$mytarget/../../wsil:messageContents[@validXml and @xmlVersion][1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1019</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_metadata))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="$mytarget/../../wsil:messageContents[@validXml = fn:true() and @xmlVersion = '1.0']">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The soap12:Envelope does not conform to XML 1.0.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope"
              priority="151018">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1018&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1018&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1018</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="&#xA;        $mytarget/../../wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'charset' and (fn:starts-with(fn:lower-case(@value), 'utf-8') or fn:starts-with(fn:lower-case(@value),'utf-16'))] or &#xA;        fn:starts-with(fn:lower-case($mytarget/../wsil:messageContents/@encoding),'utf-8') or &#xA;        fn:starts-with(fn:lower-case($mytarget/../wsil:messageContents/@encoding),'utf-16')&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Either (1a) the message contains a Content-Type header but
        no charset value, or (1b) the charset value is neither
        UTF-8 nor UTF-16, or (2) there is a BOM attribute in the
        messageContent element, but its value does not match the
        charset value, or (3) there is an XML declaration, and the
        charset value does not match its value, or (4) there is no
        BOM attribute, no XML declaration, and the charset value
        in Content-Type header is not UTF-8.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[wsil:httpHeaders/wsil:contentTypeHeader/@type = 'multipart' and&#xA;        wsil:httpHeaders/wsil:contentTypeHeader/@subtype = 'related' and&#xA;        wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'type']/@value=&#xA;        'application/xop+xml']&#xA;      "
              priority="151020">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1020&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1020&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1020</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'start-info' and @value != '']">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The XOP_ENCODED_MESSAGE does not include the start-info parameter with proper @value.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message[wsil:httpHeaders/wsil:contentTypeHeader/@type = 'multipart' and&#xA;      wsil:httpHeaders/wsil:contentTypeHeader/@subtype = 'related' and&#xA;      wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'type']/@value =&#xA;      'application/xop+xml']"
              priority="151021">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">preferred</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1021&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1021&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1021</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="some $rootContentID in&#xA;      string(wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'start']/@value)&#xA;      satisfies&#xA;      string(wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'start-info']/@value) =&#xA;      string(wsil:messageAttachments//*:mimeHeaders[&#xA;      *:mimeHeader[ fn:lower-case(@key) = 'content-id' and @value = $rootContentID]]/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'type']/@value)">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The XOP_ENCODED_MESSAGE SHOULD include the full value of the type parameter
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope&#xA;      "
              priority="151600">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1600&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1600&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_metadata" select="$mytarget/../@schemaValid[1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1600</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_metadata))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        $mytarget/../@schemaValid = fn:true()&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The envelope does not conform to the structure specified
        in SOAP 1.2 Part 1, Section 5
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope"
              priority="151881">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1881&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1881&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1881</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="count(soap12:Body/*) le 1">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The envelope does not have exactly zero or one child elements of the soap12:Body
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope[count(soap12:Body/*) &gt; 0]"
              priority="151202">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1202&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1202&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1202</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="fn:namespace-uri-from-QName(fn:node-name(soap12:Body/*)) != ''">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A child element of the soap12:Body element is not namespace
        qualified.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope"
              priority="151007">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1007&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1007&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_metadata" select="$mytarget/../@containsDTD[1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1007</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_metadata))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not(../@containsDTD = fn:true())">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The soap12:Header or soap12:Body elements in the envelope,
        were described with an included DTD.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope"
              priority="151208">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1208&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1208&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_metadata"
                    select="$mytarget/../@containsProcessingInstructions[1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1208</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_metadata))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not(../@containsProcessingInstructions = fn:true())">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        a SOAP envelope contains XML processing instructions.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope"
              priority="151033">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">preferred</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1033&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1033&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1033</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(.//*[fn:namespace-uri(.) = 'http://www.w3.org/XML/1998/namespace'])&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The SOAP envelope contains the namespace declaration
        xmlns:xml="http://www.w3.org/XML/1998/namespace".
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope"
              priority="151032">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1032&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1032&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1032</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="every $attrib in (self::node()/attribute::*,&#xA;      ./soap12:Header/attribute::*,&#xA;      ./soap12:Body/attribute::*) satisfies&#xA;      fn:namespace-uri($attrib) != 'http://www.w3.org/2003/05/soap-envelope' and&#xA;      fn:namespace-uri($attrib) != 'http://schemas.xmlsoap.org/soap/envelope/'&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The message has a soap12:Envelope, soap12:Header, or soap12:Body element with one or more
        attributes in either the "http://schemas.xmlsoap.org/soap/envelope/" or the
        "http://www.w3.org/2003/05/soap-envelope" namespace.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope[soap12:Header/wsa:Action and (fn:ends-with(soap12:Body/soap12:Fault/soap12:Code/soap12:Value,'MustUnderstand') or  fn:ends-with(soap12:Body/soap12:Fault/soap12:Code/soap12:Value, 'VersionMismatch'))]"
              priority="151035">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1035&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1035&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1035</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="normalize-space(string(./soap12:Header/wsa:Action)) eq 'http://www.w3.org/2005/08/addressing/soap/fault'">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A fault response does not contain the expected wsa:Action
        value of http://www.w3.org/2005/08/addressing/soap/fault.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message&#xA;    [/wsil:testLog/wsil:descriptionFiles/*:feature[@name = 'http://www.w3.org/2007/05/addressing/metadata/Addressing' and @mode = 'required']]/wsil:messageContents/soap12:Envelope[soap12:Body/* and  not (soap12:Body/soap12:Fault) ]"
              priority="1510400">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1040a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1040a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1040a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="$mytarget/soap12:Header/wsa:Action">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The use of WS-Addressing was required, but the message did not include wsa:Action.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;          [@type = 'request']&#xA;        /wsil:messageContents/soap12:Envelope&#xA;&#x9;[ not(soap12:Header/wsa:RelatesTo) and&#xA;&#x9;not(soap12:Header/wsa:ReplyTo/wsa:Address = 'http://www.w3.org/2005/08/addressing/none') and&#xA;&#x9;not(soap12:Header/wsa:FaultTo/wsa:Address = 'http://www.w3.org/2005/08/addressing/none')&#xA;&#x9;]&#xA;          [/wsil:testLog/wsil:descriptionFiles/wsil:feature[@name = &#34;http://www.w3.org/ns/ws-policy/Policy&#34;]/wsil:alternative/wsil:feature[@name = &#34;http://www.w3.org/2007/05/addressing/metadata/Addressing&#34;]/wsil:alternative/wsil:feature[@name = &#34;http://www.w3.org/2007/05/addressing/metadata/AnonymousResponses&#34; and @mode = &#34;required&#34;]&#xA;          ]&#xA;      "
              priority="1510401">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1040b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1040b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1040b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="&#xA;        (&#xA;          (not ($mytarget/soap12:Header/wsa:ReplyTo) or&#xA;           ($mytarget/soap12:Header/wsa:ReplyTo/wsa:Address = 'http://www.w3.org/2005/08/addressing/anonymous')&#xA;          ) and&#xA;          (not ($mytarget/soap12:Header/wsa:FaultTo) or&#xA;           ($mytarget/soap12:Header/wsa:FaultTo/wsa:Address = 'http://www.w3.org/2005/08/addressing/anonymous')&#xA;          )&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The service requires request messages to use response endpoint EPRs that contain the
        anonymous URI as the value of wsa:Address. The client sent a request with a response EPR
        that contained something other than the anonymous URI.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;          [@type = 'request']&#xA;        /wsil:messageContents/soap12:Envelope&#xA;&#x9;[ not(soap12:Header/wsa:RelatesTo) and&#xA;&#x9;not(soap12:Header/wsa:ReplyTo/wsa:Address = 'http://www.w3.org/2005/08/addressing/none') and&#xA;&#x9;not(soap12:Header/wsa:FaultTo/wsa:Address = 'http://www.w3.org/2005/08/addressing/none')&#xA;&#x9;]&#xA;          [/wsil:testLog/wsil:descriptionFiles/wsil:feature[@name=&#34;http://www.w3.org/ns/ws-policy/Policy&#34;]/wsil:alternative/wsil:feature[@name=&#34;http://www.w3.org/2007/05/addressing/metadata/Addressing&#34;]/wsil:alternative/wsil:feature[@name=&#34;http://www.w3.org/2007/05/addressing/metadata/NonAnonymousResponses&#34; and @mode=&#34;required&#34;]&#xA;          ]&#xA;      "
              priority="1510402">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1040c&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1040c&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1040c</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="&#xA;        (&#xA;          ($mytarget/soap12:Header/wsa:ReplyTo) and&#xA;          not ($mytarget/soap12:Header/wsa:ReplyTo/wsa:Address='http://www.w3.org/2005/08/addressing/anonymous') and&#xA;          not ($mytarget/soap12:Header/wsa:FaultTo/wsa:Address='http://www.w3.org/2005/08/addressing/anonymous')&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The service requires request messages to use response endpoint EPRs that contain something
        other than the anonymous URI as the value of wsa:Address. The client sent a request with
        either a response EPR that contained the anonymous URI or without the ReplyTo header, which
        implies a default [reply endpoint] with the anonymous URI.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope[soap12:Body/soap12:Fault[some $code in .//soap12:Value satisfies&#xA;&#x9;fn:contains($code,'MustUnderstand')&#xA;&#x9;]]&#xA;    [/wsil:testLog/wsil:descriptionFiles/*:feature[@name = 'http://www.w3.org/2007/05/addressing/metadata/Addressing' and (@mode = 'required' or @mode = 'supported')]] "
              priority="151041">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1041&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1041&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1041</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="$mytarget/soap12:Header[not(soap12:NotUnderstood[fn:namespace-uri-for-prefix(fn:substring-before(@qname, ':'), .) = 'http://www.w3.org/2005/08/addressing'])]&#xA; ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A MustUnderstand SOAP fault, sent from an endpoint that
            has a policy alternative containing the wsam:Addressing assertion attached to
            its WSDL endpoint subject, contains a NotUnderstood SOAP header block
            with the qname attribute value that identifies a WS-Addressing defined SOAP
            header block.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/wsil:messageContents/soap12:Envelope&#xA;        [soap12:Header[ wsa:Action and &#xA;        not  (wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]  )] &#xA;        and soap12:Body/* and  not (soap12:Body/soap12:Fault) ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1511420">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1142a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1142a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation[@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1142a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (        &#xA;        if&#xA;        ( &#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/&#xA;        wsdl:port[fn:local-name-from-QName(fn:resolve-QName(xsd:string(@binding), . )) = &#xA;        $cotarget_myOpBinding/../@name ]/wsa:EndpointReference &#xA;        )&#xA;        then&#xA;        (some $portEpr in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/&#xA;        wsdl:port[fn:local-name-from-QName(fn:resolve-QName(xsd:string(@binding), . )) = &#xA;        $cotarget_myOpBinding/../@name ]/wsa:EndpointReference satisfies&#xA;        ( $mytarget/soap12:Header/wsa:To &#xA;        )&#xA;        )&#xA;        else fn:true()&#xA;        )&#xA;        and&#xA;        (&#xA;        if&#xA;        ( $cotarget_myOpBinding/wsdl:output )&#xA;        then&#xA;        ($mytarget/soap12:Header/wsa:MessageID)&#xA;        else fn:true()&#xA;        )&#xA;        and  (:  correct wsa:Action value  :)&#xA;        (some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/&#xA;        wsdl:operation[ $cotarget_myOpBinding/@name = @name ]/wsdl:input satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        ( if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        ) ) &#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope does not conform to WS-Addressing WSDL
        Binding, Section 5.1.
        For a request message, with a wsa:Action element, defined using an rpc/lit binding, the following must hold:
        - If there is an EPR attached to the corresponding wsdl:port definition, then the wsa:To element must be present 
        - The wsa:Action value in the soap12:Header must equal to that specified from the wsdl
        - If the operation binding includes a wsdl:output element then there must be  wsa:messageID and a wsa:ReplyTo elements present in the soap12:Header
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'response']/wsil:messageContents/&#xA;        soap12:Envelope[soap12:Header[wsa:Action] and soap12:Body/* and not (soap12:Body/soap12:Fault)]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1511421">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1142b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1142b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]/&#xA;        wsdl:operation&#xA;        [fn:string-join((@name, 'Response' ),'' ) = fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:variable name="cotarget_related-Request"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/&#xA;        wsil:messageContents/soap12:Envelope[soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] ]  &#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1142b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_related-Request))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test=" &#xA;        ( &#xA;        not ($cotarget_related-Request/soap12:Header/wsa:ReplyTo) &#xA;        or &#xA;        ($cotarget_related-Request/soap12:Header/wsa:ReplyTo/wsa:Address='http://www.w3.org/2005/08/addressing/anonymous' )&#xA;        ) &#xA;        and&#xA;        ( &#xA;        $mytarget/soap12:Header/wsa:RelatesTo&#xA;        [ not ( @RelationshipType ) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        )&#xA;        and&#xA;        (&#xA;        $mytarget/soap12:Header[ not (wsa:To) or (wsa:To = 'http://www.w3.org/2005/08/addressing/anonymous' )]&#xA;        )&#xA;        and (: correct wsa:Action value :)&#xA;        (some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/&#xA;        wsdl:operation[ $cotarget_myOpBinding/@name = @name ]/wsdl:output satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        ( if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Response' )  )&#xA;        ) ) &#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope does not conform to WS-Addressing WSDL
        Binding, Section 5.1.
        For a response message with a wsa:Action element, defined using an rpc/lit binding, the following must hold:
        - the wsa:ReplyTo EPR in the related Request message must have the anonymous address
        - the wsa:To element, if present, must have the anonymous value
        - The wsa:Action value in the soap12:Header must equal to that specified from the wsdl
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/wsil:messageContents/&#xA;        soap12:Envelope&#xA;        [soap12:Body[not (soap12:Fault)] and soap12:Header&#xA;        [wsa:Action and  &#xA;        (wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] &#xA;        )&#xA;        ]&#xA;        ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1511422">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1142c&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1142c&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]/&#xA;        wsdl:operation&#xA;        [fn:string-join((@name, 'Response' ),'' ) = fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:variable name="cotarget_related-Request"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/&#xA;        wsil:messageContents/soap12:Envelope[soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] ]  &#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1142c</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_related-Request))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test=" &#xA;        ( &#xA;        ($cotarget_related-Request/soap12:Header/wsa:ReplyTo) &#xA;        and not&#xA;        ($cotarget_related-Request/soap12:Header/wsa:ReplyTo/wsa:Address='http://www.w3.org/2005/08/addressing/anonymous' )&#xA;        ) &#xA;        and&#xA;        ( &#xA;        $mytarget/soap12:Header/wsa:RelatesTo&#xA;        [ not ( @RelationshipType ) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        )&#xA;        and&#xA;        (&#xA;        $mytarget/soap12:Header[ (wsa:To) and not (wsa:To = 'http://www.w3.org/2005/08/addressing/anonymous' ) ]&#xA;        )&#xA;        and (: correct wsa:Action value :)&#xA;        (some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/&#xA;        wsdl:operation[ $cotarget_myOpBinding/@name = @name ]/wsdl:output satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        ( if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Response' )  )&#xA;        ) ) &#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope does not conform to WS-Addressing WSDL
        Binding, Section 5.1.
        For a non-anonymous response message with a wsa:Action element, defined using an rpc/lit binding, 
        the following must hold:
        - the wsa:ReplyTo EPR in the related Request message must have a non-anonymous address
        - the wsa:To element must be present, and must have a non-anonymous value 
        - The wsa:Action value in the soap12:Header must equal to that specified from the wsdl
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/wsil:messageContents/&#xA;        soap12:Envelope&#xA;        [soap12:Body[not (soap12:Fault)] and soap12:Header&#xA;        [wsa:Action and not &#xA;        (wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] &#xA;        )&#xA;        ]&#xA;        ]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies &#xA;        ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1511430">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1143a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1143a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1143a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (&#xA;        if   &#xA;        ( &#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/&#xA;        wsdl:port[fn:local-name-from-QName(fn:resolve-QName(xsd:string(@binding), . )) = &#xA;        $cotarget_myOpBinding/../@name ]/wsa:EndpointReference &#xA;        )&#xA;        then&#xA;        (some $portEpr in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/&#xA;        wsdl:port[fn:local-name-from-QName(fn:resolve-QName(xsd:string(@binding), . )) = &#xA;        $cotarget_myOpBinding/../@name ]/wsa:EndpointReference satisfies&#xA;        ( $mytarget/soap12:Header/wsa:To )&#xA;        )&#xA;        else fn:true()&#xA;        )&#xA;        and&#xA;        (&#xA;        if &#xA;        ( $cotarget_myOpBinding/wsdl:output )&#xA;        then &#xA;        ( $mytarget/soap12:Header/wsa:MessageID)&#xA;        else fn:true()&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope does not conform to WS-Addressing WSDL
        Binding, Section 5.1.
        For a request message, with a wsa:Action element, defined using a doc/lit binding, the following must hold:
        - If there is an EPR attached to the corresponding wsdl:port definition, then the wsa:To element must be present 
        - The wsa:Action value in the soap12:Header must equal to that specified from the wsdl (this is covered by the cotarget presence)
        - If the operation binding includes a wsdl:output element then there must be  wsa:messageID and a wsa:ReplyTo elements present in the soap12:Header
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'response']/wsil:messageContents/soap12:Envelope&#xA;        [soap12:Body[not (soap12:Fault) ] and soap12:Header[wsa:Action]  ]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1511431">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1143b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1143b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )&#xA;        (:&#xA;        and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Response' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        :)&#xA;        ]&#xA;      [1]"/>
      <xsl:variable name="cotarget_related-Request"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/&#xA;        wsil:messageContents/soap12:Envelope[soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]   ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1143b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_related-Request))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        ( &#xA;        not ($cotarget_related-Request/soap12:Header/wsa:ReplyTo) &#xA;        or &#xA;        ($cotarget_related-Request/soap12:Header/wsa:ReplyTo/wsa:Address='http://www.w3.org/2005/08/addressing/anonymous' )&#xA;        ) &#xA;        and&#xA;        ( &#xA;        $mytarget/soap12:Header/wsa:RelatesTo&#xA;        [ not ( @RelationshipType ) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        )&#xA;        and&#xA;        (&#xA;        $mytarget/soap12:Header[ not (wsa:To) or (wsa:To = 'http://www.w3.org/2005/08/addressing/anonymous' )]&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope does not conform to WS-Addressing WSDL
        Binding, Section 5.1.
        For a response message with a wsa:Action element, defined using a doc/lit binding, the following must hold:
        - the wsa:ReplyTo EPR in the related Request message must have the anonymous address
        - the wsa:To element, if present, must have the anonymous value
        - The wsa:Action value in the soap12:Header must equal to that specified from the wsdl (this is covered by the cotarget presence)
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/wsil:messageContents/soap12:Envelope&#xA;        [soap12:Body[not (soap12:Fault)] and soap12:Header&#xA;        [wsa:Action and  &#xA;        (wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] &#xA;        )&#xA;        ]&#xA;        ]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1511432">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1143c&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1143c&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Response' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:variable name="cotarget_related-Request"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/&#xA;        wsil:messageContents/soap12:Envelope[soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]   ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1143c</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_related-Request))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        ( &#xA;        ($cotarget_related-Request/soap12:Header/wsa:ReplyTo) &#xA;        and not &#xA;        ($cotarget_related-Request/soap12:Header/wsa:ReplyTo/wsa:Address='http://www.w3.org/2005/08/addressing/anonymous' )&#xA;        ) &#xA;        and&#xA;        ( &#xA;        $mytarget/soap12:Header/wsa:RelatesTo&#xA;        [ not ( @RelationshipType ) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        )&#xA;        and&#xA;        (&#xA;        $mytarget/soap12:Header[ (wsa:To) and not (wsa:To = 'http://www.w3.org/2005/08/addressing/anonymous' )]&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope does not conform to WS-Addressing WSDL
        Binding, Section 5.1.
        For a non anon response message with a wsa:Action element, defined using a doc/lit binding, the following must hold:
        - the wsa:ReplyTo EPR in the related Request message must have a non-anonymous address
        - the wsa:To element, must be present with a non-anonymous value
        - The wsa:Action value in the soap12:Header must equal to that specified from the wsdl (this is covered by the cotarget presence)
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope[soap12:Header/wsa:ReplyTo/wsa:ReferenceParameters/*]&#xA;      "
              priority="1510430">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1043a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1043a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_related-Response"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;          [@type = 'response' or&#xA;            ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;            [not(@RelationshipType) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply')]&#xA;          ]&#xA;        /wsil:messageContents/soap12:Envelope&#xA;          [soap12:Header/wsa:RelatesTo[not(@RelationshipType) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply')] =&#xA;           $mytarget/soap12:Header/wsa:MessageID]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1043a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_related-Response))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (&#xA;        if&#xA;        (&#xA;          ($cotarget_related-Response/soap12:Header/wsa:Action) and&#xA;          (not($cotarget_related-Response/soap12:Body/soap12:Fault) or&#xA;           (not($mytarget/soap12:Header/wsa:FaultTo) and&#xA;            $cotarget_related-Response/soap12:Header/wsa:Action ne 'http://www.w3.org/2005/08/addressing/fault'))&#xA;        )&#xA;        then&#xA;        (&#xA;          &#xA;          every $refP in $mytarget/soap12:Header/wsa:ReplyTo/wsa:ReferenceParameters/*&#xA;          satisfies&#xA;            some $header in $cotarget_related-Response/soap12:Header/*[@wsa:IsReferenceParameter='1'or  @wsa:IsReferenceParameter = 'true']&#xA;            satisfies&#xA;              fn:resolve-QName(fn:name($refP), $refP) = fn:resolve-QName(fn:name($header), $header)&#xA;        )&#xA;        else fn:true()&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The response to a message that contained reference parameters in the ReplyTo EPR is missing
        one or more of those reference parameters in its SOAP headers.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope[soap12:Header/wsa:FaultTo/wsa:ReferenceParameters/*]&#xA;      "
              priority="1510431">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1043b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1043b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_related-Response"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;          [@type = 'response' or&#xA;            ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;            [not(@RelationshipType) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply')]&#xA;          ]&#xA;        /wsil:messageContents/soap12:Envelope&#xA;          [soap12:Header/wsa:RelatesTo[not(@RelationshipType) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply')] =&#xA;           $mytarget/soap12:Header/wsa:MessageID]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1043b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_related-Response))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (&#xA;        if&#xA;        (&#xA;          ($cotarget_related-Response/soap12:Header/wsa:Action) and&#xA;          ($cotarget_related-Response/soap12:Body/soap12:Fault)&#xA;        )&#xA;        then&#xA;        (&#xA;          &#xA;          every $refP in $mytarget/soap12:Header/wsa:FaultTo/wsa:ReferenceParameters/*&#xA;          satisfies&#xA;            some $header in $cotarget_related-Response/soap12:Header/*[@wsa:IsReferenceParameter='1'or  @wsa:IsReferenceParameter = 'true']&#xA;            satisfies&#xA;              fn:resolve-QName(fn:name($refP), $refP) = fn:resolve-QName(fn:name($header), $header)&#xA;        )&#xA;        else fn:true()&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The fault response to a message that contained reference parameters in the FaultTo EPR is
        missing one or more of those reference parameters in its SOAP headers.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/wsil:messageContents/&#xA;        soap12:Envelope&#xA;        [soap12:Body[not (soap12:Fault)] and soap12:Header[not(wsa:To) ]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies &#xA;        ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) and&#xA;        ( some $port in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/wsdl:port satisfies&#xA;        not(wsa:EndpointReference)&#xA;        )&#xA;        ]&#xA;      "
              priority="1511530">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1153a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1153a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1153a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/wsdl:port[&#xA;        fn:local-name-from-QName(fn:resolve-QName(xsd:string(@binding), . )) =&#xA;        $cotarget_myOpBinding/../@name and not(wsa:EndpointReference) ]&#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (&#xA;        if   &#xA;        ( &#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/&#xA;        wsdl:port[fn:local-name-from-QName(fn:resolve-QName(xsd:string(@binding), . )) = &#xA;        $cotarget_myOpBinding/../@name and not(wsa:EndpointReference)] &#xA;        )&#xA;        then&#xA;        (&#xA;        not (/wsil:testLog/wsil:messageLog/wsil:message[(@type = 'response' and @conversation = $mytarget/../../@conversation) or &#xA;        (.//soap12:Envelope/soap12:Header/wsa:RelatesTo =  $mytarget/soap12:Header/wsa:MessageID)]&#xA;        /wsil:messageContents/soap12:Envelope/soap12:Body/soap12:Fault )&#xA;        )&#xA;        else fn:true()&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope for a doc/lit bound request message, without wsa:To in a message bound to a port that is NOT extended with wsa:EndpointReference has generated a Fault in response. Verify that this fault is not caused by the absence of wsa:To.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/wsil:messageContents/soap12:Envelope&#xA;        [soap12:Header[ &#xA;        not  (wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]  ) and not(wsa:To)] &#xA;        and soap12:Body/* &#xA;        and  not (soap12:Body/soap12:Fault) ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        (some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)) and&#xA;        ( some $port in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/wsdl:port satisfies&#xA;        not(wsa:EndpointReference))&#xA;        ]&#xA;      "
              priority="1511531">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1153b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1153b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation[@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1153b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/wsdl:port[&#xA;        fn:local-name-from-QName(fn:resolve-QName(xsd:string(@binding), . )) =&#xA;        $cotarget_myOpBinding/../@name and not(wsa:EndpointReference) ]&#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (        &#xA;        if   &#xA;        ( &#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/&#xA;        wsdl:port[fn:local-name-from-QName(fn:resolve-QName(xsd:string(@binding), . )) = &#xA;        $cotarget_myOpBinding/../@name and not(wsa:EndpointReference)] &#xA;        )&#xA;        then&#xA;        (&#xA;        not (/wsil:testLog/wsil:messageLog/wsil:message[(@type = 'response' and @conversation = $mytarget/../../@conversation) or &#xA;        (.//soap12:Envelope/soap12:Header/wsa:RelatesTo =  $mytarget/soap12:Header/wsa:MessageID)]&#xA;        /wsil:messageContents/soap12:Envelope/soap12:Body/soap12:Fault )&#xA;        )&#xA;        else fn:true()&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope for a rpc/lit bound request message, without wsa:To in a message bound to a port that is NOT extended with wsa:EndpointReference has generated a Fault in response. Verify that this fault is not caused by the absence of wsa:To.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/&#xA;        soap12:Envelope&#xA;        [soap12:Body[not (soap12:Fault)] and&#xA;        not(soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] ) and &#xA;        ((some $repto in soap12:Header/wsa:ReplyTo satisfies  &#xA;        fn:contains($repto, 'anonymous')) or not(soap12:Header/wsa:ReplyTo) )&#xA;        ]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies &#xA;        ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) and&#xA;        ( some $port in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/wsdl:port satisfies&#xA;        not(wsa:EndpointReference)&#xA;        )&#xA;        ]&#xA;      "
              priority="1511250">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1125a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1125a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1125a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="$mytarget/../../@type = 'request'">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope for a WSDL doc/lit bound request message, with a wsa:ReplyTo anonymous, was
        sent over an HTTP response.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/&#xA;        soap12:Envelope&#xA;        [soap12:Body[not (soap12:Fault)] and&#xA;        not(soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] ) and &#xA;        ((some $repto in soap12:Header/wsa:ReplyTo satisfies  &#xA;        fn:contains($repto, 'anonymous')) or not(soap12:Header/wsa:ReplyTo) )&#xA;        ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        (some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)) and&#xA;        ( some $port in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:service/wsdl:port satisfies&#xA;        not(wsa:EndpointReference))&#xA;        ]&#xA;      "
              priority="1511251">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1125b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1125b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation[@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1125b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="$mytarget/../../@type = 'request'">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope for a WSDL rpc/lit bound request message, with a wsa:ReplyTo anonymous, was sent over an HTTP response.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope&#xA;        [soap12:Body[not (soap12:Fault) ] and&#xA;        soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]  and &#xA;        (some $respenv in . satisfies&#xA;        some $req in /wsil:testLog/wsil:messageLog/wsil:message satisfies&#xA;        $req/wsil:messageContents/soap12:Envelope/soap12:Header/wsa:MessageID = &#xA;        $respenv/soap12:Header/wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] and $req/wsil:messageContents/soap12:Envelope/soap12:Header[fn:contains(wsa:ReplyTo[1]/wsa:Address , 'http://www.w3.org/2005/08/addressing/anonymous') or not(wsa:ReplyTo)]  )&#xA;        ]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1511260">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1126a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1126a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   &#xA;        and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Response' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        ) &#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1126a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="$mytarget/../../@type = 'response'">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope for a WSDL doc/lit bound response message, related to a request containing a
        wsa:ReplyTo anonymous, was sent over an HTTP request.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message/wsil:messageContents/soap12:Envelope&#xA;        [soap12:Body[not (soap12:Fault) ] and&#xA;        soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]  and &#xA;        (some $respenv in . satisfies&#xA;        some $req in /wsil:testLog/wsil:messageLog/wsil:message satisfies&#xA;        $req/wsil:messageContents/soap12:Envelope/soap12:Header/wsa:MessageID = &#xA;        $respenv/soap12:Header/wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] and $req/wsil:messageContents/soap12:Envelope/soap12:Header[fn:contains(wsa:ReplyTo[1]/wsa:Address, 'http://www.w3.org/2005/08/addressing/anonymous') or not(wsa:ReplyTo)]  )&#xA;        ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1511261">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1126b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1126b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]/&#xA;        wsdl:operation&#xA;        [fn:string-join((@name, 'Response' ),'' ) = fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1126b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="$mytarget/../../@type = 'response'">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An envelope for a WSDL rpc/lit bound response message, related to a request containing a
        wsa:ReplyTo anonymous, was sent over an HTTP request.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[wsil:messageContents/soap12:Envelope/soap12:Header/wsa:Action]&#xA;      "
              priority="151144">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1144&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1144&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP1761=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP1761&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1144</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP1761&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP1761&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP1761</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="&#xA;        (wsil:messageContents/soap12:Envelope/soap12:Header/wsa:Action/text() = wsil:httpHeaders/wsil:httpHeader[fn:lower-case(@key) = 'action']/@value) or not(wsil:httpHeaders/wsil:httpHeader[fn:lower-case(@key) = 'action'])&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A message did not specify an action HTTP header with either a value that is an absolute URI
        that has the same value as the value of the wsa:Action SOAP header, or a value of "" (empty
        string).
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request'and &#xA;        fn:contains(wsil:httpHeaders/wsil:requestLine/text(), 'HTTP')]&#xA;      "
              priority="151002">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1002&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1002&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1002</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="fn:contains(wsil:httpHeaders/wsil:requestLine/text(), 'HTTP/1.0') or fn:contains(wsil:httpHeaders/wsil:requestLine/text(), 'HTTP/1.1') ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The message that is sent over HTTP, is not sent using HTTP/1.1 or HTTP/1.0.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message"
              priority="151001">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">preferred</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1001&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1001&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP1002=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP1002&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1001</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP1002&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP1002&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP1002</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="contains(wsil:httpHeaders/wsil:requestLine/text(), 'HTTP/1.1')">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The message is not sent using HTTP/1.1.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message[@type = 'request'][wsil:httpHeaders/wsil:contentTypeHeader]&#xA;      "
              priority="151006">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1006&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1006&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP1761=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP1761&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1006</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP1761&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP1761&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP1761</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="&#xA;        every $par in wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter satisfies &#xA;        not($par/@quoted) or &#xA;        not(fn:lower-case($par/@key) eq 'type' or fn:lower-case($par/@key) eq 'start-info' or fn:lower-case($par/@key) eq 'action' or fn:lower-case($par/@key) eq 'boundary') or&#xA;        $par/@quoted = fn:true()&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        action HTTP header does not contain a quoted string.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [ (@type = 'response' and &#xA;&#x9;(some $resp in . satisfies &#xA;&#x9;some $req in /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request' and &#xA;        @conversation = $resp/@conversation] satisfies &#xA;&#x9;$req//wsa:*&#xA;&#x9;)&#xA;&#x9;)&#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]&#xA;        ]&#xA;        [wsil:messageContents/soap12:Envelope[not(soap12:Body/soap12:Fault)]]&#xA;      "
              priority="151146">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1146&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1146&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myRequestMsg"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [ @type = 'request' and &#xA;&#x9;(if (not(./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:MessageID) ) then (&#xA;        @conversation = $mytarget/../../@conversation) else &#xA;        (./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]&#xA;        ))&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1146</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myRequestMsg))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;&#x9;((not($cotarget_myRequestMsg/wsil:messageContents/soap12:Envelope/soap12:Header/wsa:ReplyTo) or&#xA;&#x9;$cotarget_myRequestMsg/wsil:messageContents/soap12:Envelope/soap12:Header/wsa:ReplyTo/wsa:Address = &#xA;&#x9;'http://www.w3.org/2005/08/addressing/anonymous')&#xA;&#x9;and&#xA;&#x9;$mytarget[@type = 'response']/wsil:messageContents/soap12:Envelope/soap12:Header&#xA;        [ wsa:To = 'http://www.w3.org/2005/08/addressing/anonymous'  or&#xA;&#x9;not(wsa:To )]) or&#xA;        (&#xA;        $mytarget/wsil:messageContents/soap12:Envelope/soap12:Header/wsa:To = &#xA;&#x9;$cotarget_myRequestMsg/wsil:messageContents/soap12:Envelope/soap12:Header/wsa:ReplyTo/wsa:Address&#xA;&#x9;)&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A response message was sent to a destination other than the expected endpoint,
        i.e. different from wsa:ReplyTo in the request message.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] and &#xA;        wsil:messageContents/soap12:Envelope/soap12:Body[not(soap12:Fault)]&#xA;        and &#xA;        (some $req in /wsil:testLog/wsil:messageLog/wsil:message satisfies&#xA;        $req/wsil:messageContents/soap12:Envelope/soap12:Header/wsa:MessageID = &#xA;        wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] and &#xA;        $req/wsil:messageContents/soap12:Envelope/soap12:Header[&#xA;        wsa:ReplyTo[1] and &#xA;        not(fn:contains(wsa:ReplyTo[1]/wsa:Address, 'http://www.w3.org/2005/08/addressing/anonymous'))]&#xA;        )]&#xA;      "
              priority="1511520">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1152a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1152a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myRequestMsg"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [wsil:messageContents/soap12:Envelope/soap12:Header/wsa:MessageID = &#xA;        $mytarget/wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1152a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myRequestMsg))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        ($mytarget/@type = 'request') and  &#xA;        (&#xA;        $mytarget/wsil:messageContents/soap12:Envelope/soap12:Header&#xA;        [ (wsa:To) and not (fn:contains(wsa:To[1], 'http://www.w3.org/2005/08/addressing/anonymous' )) ]&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A response message was not sent in the entity body of an HTTP
        request in a separate HTTP connection as required by the
        (non-anonymous) response EPR.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] and&#xA;        wsil:messageContents/soap12:Envelope/soap12:Body[soap12:Fault] and&#xA;        wsil:messageContents/soap12:Envelope/soap12:Header[not(wsa:Action) or not(fn:starts-with(wsa:Action,'http://www.w3.org/2005/08/addressing/' ))]&#xA;        and &#xA;        (some $req in /wsil:testLog/wsil:messageLog/wsil:message satisfies&#xA;        $req/wsil:messageContents/soap12:Envelope/soap12:Header/wsa:MessageID = &#xA;        wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] and &#xA;        $req/wsil:messageContents/soap12:Envelope/soap12:Header[&#xA;        wsa:FaultTo[1] and  &#xA;        not(fn:contains(wsa:FaultTo[1]/wsa:Address, 'http://www.w3.org/2005/08/addressing/anonymous'))] &#xA;        )]&#xA;      "
              priority="1511521">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1152b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1152b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myRequestMsg"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [wsil:messageContents/soap12:Envelope/soap12:Header/wsa:MessageID = &#xA;        $mytarget/wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1152b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myRequestMsg))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        ($mytarget/@type = 'request') and  &#xA;        (&#xA;        $mytarget/wsil:messageContents/soap12:Envelope/soap12:Header&#xA;        [ (wsa:To) and not (fn:contains(wsa:To[1], 'http://www.w3.org/2005/08/addressing/anonymous' )) ]&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A response message was not sent in the entity body of an HTTP
        request in a separate HTTP connection as required by the
        (non-anonymous) response EPR.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[ not (wsil:messageContents/soap12:Envelope/soap12:Body/soap12:Fault) and&#xA;&#x9;wsil:messageContents/soap12:Envelope/soap12:Header&#xA;        [(wsa:To) and not (fn:contains(wsa:To[1], 'http://www.w3.org/2005/08/addressing/anonymous' )) ]]&#xA;      "
              priority="1511522">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1152c&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1152c&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1152c</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="$mytarget/@type = 'request'">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A message with a non-anonymous destination was not sent in the entity body 
        of an HTTP request in a separate HTTP connection as required by the
        (non-anonymous) destination EPR.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile[fn:prefix-from-QName(fn:node-name(*:definitions)) eq 'wsdl' or wsdl:definitions]"
              priority="152703">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2703&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2703&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2703</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="fn:namespace-uri-from-QName(fn:node-name(./*:definitions)) eq 'http://schemas.xmlsoap.org/wsdl/' or ./*:bindingTemplate">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The wsdl:definitions is not a well-formed XML 1.0
        document, or WSDL definition does not conform to the schema located at
        http://schemas.xmlsoap.org/wsdl/soap/2003-02-11.xsd for
        some element using the WSDL-SOAP binding namespace, or
        does not conform to the schema located at
        http://schemas.xmlsoap.org/wsdl/2003-02-11.xsd for some
        element using the WSDL namespace.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions"
              priority="152756">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2756&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2756&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2756</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not (.//wsoap12:operation/@soapActionRequired)">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A DESCRIPTION include the wsoap12:soapActionRequired attribute	
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message[wsil:httpHeaders]"
              priority="151761">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">preferred</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1761&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1761&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1761</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(wsil:httpHeaders/wsil:httpHeader[fn:lower-case(@key) = 'soapaction'])">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A SOAP1.2 SENDER has included the SOAPAction HTTP header (instead of using the 'action' header)
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:messageLog/wsil:message[not(wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'action'])]/wsil:messageContents/soap12:Envelope"
              priority="151757">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1757&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1757&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP1761=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP1761&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1757</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP1761&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP1761&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP1761</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="not (/wsil:testLog/wsil:messageLog/wsil:message[(@type = 'response' and @conversation = $mytarget/../../@conversation) or (.//soap12:Envelope/soap12:Header/wsa:RelatesTo =  $mytarget/soap12:Header/wsa:MessageID)]/wsil:messageContents/soap12:Envelope/soap12:Body/soap12:Fault )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A soap Fault has been generated when receiving a message with no action parameter on the Content-Type HTTP header field: 
        verify that this Fault has another cause - it must not be caused by this parameter absence.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions[.//wsoap12:*]&#xA;      "
              priority="152704">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2704&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2704&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_metadata" select="$mytarget/../@schemaValid[1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2704</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_metadata))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        $mytarget/../@schemaValid = fn:true()&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The wsdl:definitions is using the WSDL SOAP binding namespace
        (prefixed "wsoap12" in this Profile) in a way that is not valid according
        to the XML Schema found at "
        
          http://schemas.xmlsoap.org/wsdl/soap12/wsdl11soap12.xsd
        
        ". 
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions[wsdl:import]&#xA;      "
              priority="152101">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2101&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2101&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2101</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="&#xA;        every $wsdlImp in $mytarget/wsdl:import  satisfies&#xA;        some $wsdlFile in &#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile[@filename=$wsdlImp/@location] &#xA;        satisfies &#xA;        (  (fn:namespace-uri($wsdlFile/*[1])  =  'http://schemas.xmlsoap.org/wsdl/'        ) and&#xA;        ( fn:local-name($wsdlFile/*[1])  =  'definitions'   )        &#xA;        ) &#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A wsdl:import element does not contain a reference to
        another WSDL description.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions[wsdl:import]"
              priority="152803">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2803&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2803&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2703=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2703&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2803</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2703</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="every $imp in wsdl:import[@namespace] satisfies (starts-with($imp/@namespace, 'http://') or starts-with($imp/@namespace, 'HTTP://') or starts-with($imp/@namespace, 'urn:') or starts-with($imp/@namespace, 'URN:') or starts-with($imp/@namespace, 'ft') or starts-with($imp/@namespace, 'FT'))">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">The wsdl:import element's "namespace" attribute value is a
      relative URI.</xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions[descendant::xsd:import]"
              priority="152103">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2103&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2103&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2103</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="every $imp in descendant::xsd:import satisfies ($imp/ancestor::xsd:schema and $imp/ancestor::wsdl:types)">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A XML schema import element was found outside of an
        xsd:schema element.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions[wsdl:types/xsd:schema/xsd:import]&#xA;      "
              priority="152202">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2202&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2202&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2202</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="&#xA;        every $schImp in $mytarget/wsdl:types/xsd:schema/xsd:import[@schemaLocation]  &#xA;        satisfies&#xA;        ( some $schFile in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile[@filename=$schImp/@schemaLocation] &#xA;        satisfies (not ($schFile/@encoding) or &#xA;        $schFile/@encoding = 'UTF-8' or &#xA;        $schFile/@encoding = 'UTF-16' or &#xA;        $schFile/@encoding = 'utf-8' or &#xA;        $schFile/@encoding = 'utf-16')&#xA;        ) &#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The XML declaration statement within an imported XML
        Schema does not use expected encoding (UTF-8 or UTF-16).
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:import"
              priority="152098">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2098&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2098&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2098</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="@location and @location != '' ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A wsdl:import element does not have a "location"
        attribute, or has an empty value for the location
        attribute.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions[wsdl:import]&#xA;      "
              priority="152105">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2105&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2105&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2105</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="&#xA;        not(wsdl:import/preceding-sibling::wsdl:*[(local-name-from-QName(node-name(.)) != 'documentation') and &#xA;        (local-name-from-QName(node-name(.)) != 'import')])&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A wsdl:import element in the WSDL namespace under the
        wsdl:definitions element, is preceded by child elements
        other than wsdl:documentation elements.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions[wsdl:types]&#xA;      "
              priority="152018">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2018&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2018&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2703=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2703&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2018</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2703</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="&#xA;        not(wsdl:types/preceding-sibling::wsdl:*[(local-name-from-QName(node-name(.)) != 'documentation') and &#xA;        (local-name-from-QName(node-name(.)) != 'import') and (local-name-from-QName(node-name(.)) != 'types')])&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        wsdl:types element(s) in the WSDL namespace of the
        wsdl:definitions element were preceded by child elements
        other than wsdl:documentation or wsdl:import elements.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions&#xA;      "
              priority="152201">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2201&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2201&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_metadata" select="$mytarget/../@encoding[1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2201</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_metadata))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="fn:starts-with(fn:lower-case(../@encoding), 'utf-8') or fn:starts-with(fn:lower-case(../@encoding), 'utf-16') ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        XML declaration statement within WSDL document does not
        use expected encoding (UTF-8 or UTF-16).
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:import"
              priority="152104">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2104&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2104&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2101=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2101&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2104</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2101&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2101&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2101</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="some $wimp in . satisfies&#xA;      some $descFile in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile[fn:ends-with($wimp/@location, @filename)] satisfies&#xA;      ($descFile/wsdl:definitions/@targetNamespace = $wimp/@namespace)&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The targetNamespace attribute on the wsdl:definitions
        element for an imported WSDL description does not have the
        same value as the namespace attribute on the wsdl:import
        element that imported the WSDL description.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions"
              priority="152416">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2416&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2416&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2416</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="(every $qref in $mytarget/wsdl:service/wsdl:port/@binding satisfies &#xA;      ( some $ns in fn:namespace-uri-from-QName(fn:resolve-QName (xsd:string($qref),$qref/..) ) satisfies &#xA;      ( ($mytarget/@targetNamespace = $ns ) or (some $wimp in $mytarget/wsdl:import satisfies $wimp/@namespace = $ns ) ) ) ) &#xA;      and &#xA;      (every $qref in $mytarget/wsdl:binding/@type satisfies &#xA;      ( some $ns in fn:namespace-uri-from-QName(fn:resolve-QName (xsd:string($qref),$qref/..) ) satisfies &#xA;      ( ($mytarget/@targetNamespace = $ns ) or (some $wimp in $mytarget/wsdl:import satisfies $wimp/@namespace = $ns ) ) ) ) &#xA;      and &#xA;      (every $qref in $mytarget/wsdl:portType/wsdl:operation/wsdl:input/@message satisfies &#xA;      ( some $ns in fn:namespace-uri-from-QName(fn:resolve-QName (xsd:string($qref),$qref/..) ) satisfies &#xA;      ( ($mytarget/@targetNamespace = $ns ) or (some $wimp in $mytarget/wsdl:import satisfies $wimp/@namespace = $ns ) ) ) ) &#xA;      and &#xA;      (every $qref in $mytarget/wsdl:portType/wsdl:operation/wsdl:output/@message satisfies &#xA;      ( some $ns in fn:namespace-uri-from-QName(fn:resolve-QName (xsd:string($qref),$qref/..) ) satisfies &#xA;      ( ($mytarget/@targetNamespace = $ns ) or (some $wimp in $mytarget/wsdl:import satisfies $wimp/@namespace = $ns ) ) ) ) &#xA;      and &#xA;      (every $qref in $mytarget/wsdl:portType/wsdl:operation/wsdl:fault/@message satisfies &#xA;      ( some $ns in fn:namespace-uri-from-QName(fn:resolve-QName (xsd:string($qref),$qref/..) ) satisfies &#xA;      ( ($mytarget/@targetNamespace = $ns ) or (some $wimp in $mytarget/wsdl:import satisfies $wimp/@namespace = $ns ) ) ) ) &#xA;      and &#xA;      (every $qref in $mytarget/wsdl:binding/wsdl:operation/wsdl:*/wsoap12:header/@message satisfies &#xA;      ( some $ns in fn:namespace-uri-from-QName(fn:resolve-QName (xsd:string($qref),$qref/..) ) satisfies &#xA;      ( ($mytarget/@targetNamespace = $ns ) or (some $wimp in $mytarget/wsdl:import satisfies $wimp/@namespace = $ns ) ) ) ) &#xA;      and &#xA;      (every $qref in $mytarget/wsdl:binding/wsdl:operation/wsdl:*/wsoap12:headerfault/@message satisfies &#xA;      ( some $ns in fn:namespace-uri-from-QName(fn:resolve-QName (xsd:string($qref),$qref/..) ) satisfies &#xA;      ( ($mytarget/@targetNamespace = $ns ) or (some $wimp in $mytarget/wsdl:import satisfies $wimp/@namespace = $ns ) ) ) )  &#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">This DESCRIPTION uses QName references to WSDL components in namespaces that are neither imported, nor defined in the referring WSDL document
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions"
              priority="152417">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2417&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2417&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2417</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="(every $qref in $mytarget/wsdl:message/wsdl:part/@element satisfies &#xA;      ( some $ns in fn:namespace-uri-from-QName(fn:resolve-QName (xsd:string($qref),$qref/..) ) satisfies &#xA;      ( ($mytarget/wsdl:types/xsd:schema/@targetNamespace = $ns ) or &#xA;      (some $simp in $mytarget/wsdl:types/xsd:schema/xsd:import satisfies &#xA;      $simp/@namespace = $ns ) ) ) ) &#xA;      and &#xA;      (every $qref in $mytarget/wsdl:message/wsdl:part/@type satisfies &#xA;      ( some $ns in fn:namespace-uri-from-QName(fn:resolve-QName (xsd:string($qref),$qref/..) ) satisfies &#xA;      ( ($mytarget/@targetNamespace = $ns ) or &#xA;      (some $simp in $mytarget/wsdl:types/xsd:schema/xsd:import satisfies &#xA;      $simp/@namespace = $ns ) or &#xA;      ($ns = 'http://www.w3.org/2001/XMLSchema' ) ) ) )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">A QName reference to a Schema component in a DESCRIPTION does not use the namespace defined in the 
      targetNamespace 
      attribute on the 
      xsd:schema 
      element, or a namespace defined in the 
      namespace 
      attribute on an 
      xsd:import 
      element within the 
      xsd:schema 
      element. 
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions[wsdl:types/xsd:schema/xsd:import]&#xA;      "
              priority="152106">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2106&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2106&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2106</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="&#xA;        every $schemaImp in $mytarget/wsdl:types/xsd:schema/xsd:import[@schemaLocation] satisfies&#xA;        some $impSchemaFile in &#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile[@filename=$schemaImp/@schemaLocation] &#xA;        satisfies&#xA;        (&#xA;        fn:namespace-uri($impSchemaFile/*[1])='http://www.w3.org/2001/XMLSchema'&#xA;        and&#xA;        fn:local-name($impSchemaFile/*[1])='schema' &#xA;        ) &#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        xsd:import element does not resolve to document whose root element is not "schema" from xsd namespace
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions[wsdl:types/xsd:schema] &#xA;      "
              priority="152107">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2107&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2107&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2107</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="wsdl:types/xsd:schema[@targetNamespace != '' or (count(xsd:import) + count(xsd:annotation)) = count(child::*)]">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A xsd:schema element contained in a wsdl:types element
        does not have a targetNamespace attribute with a valid and
        non-null value, while having child element(s) other than
        xsd:import or xsd:annotation.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:types[xsd:schema] "
              priority="1521081">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2108b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2108b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2108b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not (xsd:schema[descendant::xsd:extension/@base = &#34;soapenc:Array&#34; or descendant::xsd:restriction/@base = &#34;soapenc:Array&#34;])">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An Array declaration uses - restricts or extends - the
        soapenc:Array type, or the wsdl:arrayType attribute is
        used in the type declaration.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:types[xsd:schema]"
              priority="1521080">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2108a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2108a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2108a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not (xsd:schema/descendant::*/@wsdl:arrayType)">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An Array declaration uses - restricts or extends - the
        soapenc:Array type, or the wsdl:arrayType attribute is
        used in the type declaration.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="//soap12:Envelope"
              priority="151204">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1204&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1204&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1204</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not (descendant::*[@soapenc:arrayType])">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The soap12:Body of an envelope contains the
        soapenc:arrayType attribute.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[not(.//wsoap12:*[@style = 'rpc'])]&#xA;      "
              priority="152111">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2111&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2111&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2017=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2017&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2111</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2017</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="not(.//wsoap12:body[@parts and contains(@parts,&#34; &#34;)])">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        One or more wsoap12:body element(s) in a document-literal
        soabinding does not have at most one part listed in the
        parts attribute.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[not(.//wsoap12:*[@style = 'rpc'])]&#xA;      "
              priority="152119">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2119&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2119&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2017=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2017&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2119</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2017</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="every $sbody in wsdl:operation//wsoap12:body[not(@parts)] satisfies&#xA;      some $msgname in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[@name = $sbody/../../@name]/*[local-name(.) = local-name($sbody/..)]/@message satisfies count(/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = $msgname]/wsdl:part) le 1&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A document-literal binding which does not specify the
        parts attribute, has more than one wsdl:part in the
        associated wsdl:message element.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]"
              priority="152013">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2013&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2013&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2017=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2017&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2013</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2017</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="every $sbody in wsdl:operation//wsoap12:body satisfies &#xA;&#xA;      some $msgname in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[@name = $sbody/../../@name]/*[local-name(.) = local-name($sbody/..)]/@message &#xA;&#xA;      satisfies &#xA;&#xA;      every $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = $msgname]/wsdl:part&#xA;      satisfies $mpart/@type or $sbody/@parts and not(contains($sbody/@parts, $mpart/@name))&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        soabinding (in wsoap12:body elements) refers to part(s)
        that do not have the "type" attribute.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[not(.//wsoap12:*[@style = 'rpc'])]&#xA;      "
              priority="152012">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2012&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2012&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2017=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2017&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2012</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2017</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="every $sbody in wsdl:operation//wsoap12:body satisfies&#xA;      some $msgname in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[@name = $sbody/../../@name]/*[local-name(.) = local-name($sbody/..)]/@message satisfies &#xA;      every $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = $msgname]/wsdl:part&#xA;      satisfies $mpart/@element or $sbody/@parts and not(contains($sbody/@parts, $mpart/@name))">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The binding (in wsoap12:body elements) refers to part(s)
        of a soap12:Body element that do not have the "element"
        attribute.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request'&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and  not (soap12:Body//soap12:Fault) ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1512120">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1212a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1212a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation[@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1212a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        some $mbody in ./soap12:Body satisfies&#xA;        some $dbody in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation[@name = fn:local-name($mbody/*[1])]/wsdl:input/wsoap12:body satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[@name = fn:local-name($mbody/*[1])]/*[fn:local-name(.) = 'input'] satisfies&#xA;        some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = fn:tokenize(xsd:string($dopmsg/@message), ':' )[fn:last()]] satisfies&#xA;        ( not(wsdl:part) and not($mbody/*/* )) or&#xA;        (every $mpart in $dmesg/wsdl:part satisfies&#xA;        fn:count($mbody/*/*[fn:local-name(.) = $mpart/@name]) eq 1  or ($dbody/@parts and not(contains($dbody/@parts, $mpart/@name))))&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The content of the soap12:Body element of request message is inconsistent with
        its description. The envelope does not contain exactly one
        part accessor element for each of the wsdl:part elements
        bound to the envelope's corresponding wsoap12:body
        element.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and not (soap12:Body/soap12:Fault)]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1512121">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1212b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1212b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]/&#xA;        wsdl:operation&#xA;        [fn:string-join((@name, 'Response' ),'' ) = fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1212b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        some $mbody in ./soap12:Body satisfies&#xA;        some $dbody in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation[fn:string-join((@name, 'Response'),'')  = fn:local-name($mbody/*[1])]/wsdl:output/wsoap12:body satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[fn:string-join((@name, 'Response'),'') = fn:local-name($mbody/*[1])]/*[fn:local-name(.) = 'output' ] satisfies&#xA;        some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = fn:tokenize(xsd:string($dopmsg/@message), ':' )[fn:last()] and wsdl:part/@type] satisfies&#xA;        every $mpart in $dmesg/wsdl:part satisfies&#xA;        fn:count($mbody/*/*[fn:local-name(.) = $mpart/@name]) eq 1  or ($dbody/@parts and not(contains($dbody/@parts, $mpart/@name)))&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The content of the soap12:Body element of resonse message is inconsistent with
        its description. The envelope does not contain exactly one
        part accessor element for each of the wsdl:part elements
        bound to the envelope's corresponding wsoap12:body
        element.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request'&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body[not (soap12:Fault)]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1512130">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1213a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1213a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1213a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        some $myOpBind in $cotarget_myOpBinding satisfies&#xA;        (&#xA;        $myOpBind/../wsoap12:binding[ not (@style = 'rpc' )] and&#xA;        $myOpBind/wsoap12:operation[ not (@style = 'rpc' )] and &#xA;        $myOpBind/wsdl:input/wsoap12:body[@parts and (@parts = '' or @parts = ' ' )]&#xA;        )&#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="count(./soap12:Body/*) eq 0">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">The request message soap12:Body element must be empty when, in the corresponding doc-literal description, the value of the parts attribute of wsoap12:body is an empty string.</xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body[not (soap12:Fault)]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1512131">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1213b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1213b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Response' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1213b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        some $myOpBind in $cotarget_myOpBinding satisfies&#xA;        (&#xA;        $myOpBind/../wsoap12:binding[ not (@style = 'rpc' )] and&#xA;        $myOpBind/wsoap12:operation[ not (@style = 'rpc' )] and &#xA;        $myOpBind/wsdl:input/wsoap12:body[@parts and (@parts = '' or @parts = ' ' )]&#xA;        )&#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="count(./soap12:Body/*) eq 0">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">The response message soap12:Body element must be empty when, in the corresponding doc-literal description, the value of the parts attribute of wsoap12:body is an empty string.</xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="        &#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request'&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and  not (soap12:Body/soap12:Fault) ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1512140">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1214a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1214a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation&#xA;        [@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1214a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        $cotarget_myOpBinding/wsdl:input/wsoap12:body[@parts and (@parts = '' or @parts =  ' '  )]  &#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="count(./soap12:Body/*/*) eq 0">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The content of the request message soap12:Body element is inconsistent with
        its description. The envelope must not have any part
        accessor elements when, in the corresponding rpc-literal
        description, the value of the parts attribute of
        wsoap12:body is an empty string.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/&#xA;        soap12:Envelope[soap12:Body/* and not (soap12:Body/soap12:Fault)]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1512141">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1214b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1214b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]/&#xA;        wsdl:operation&#xA;        [fn:string-join((@name, 'Response' ),'' ) = fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1214b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        $cotarget_myOpBinding/wsdl:output/wsoap12:body[@parts and (@parts = '' or @parts =  ' '  )]  &#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="count(./soap12:Body/*/*) eq 0">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The content of the response message soap12:Body element is inconsistent with
        its description. The envelope must not have any part
        accessor elements when, in the corresponding rpc-literal
        description, the value of the parts attribute of
        wsoap12:body is an empty string.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:header[@part] or .//wsoap12:headerfault[@part] or .//wsdl:fault/wsoap12:fault[@name] ]"
              priority="152113">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2113&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2113&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2113</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="(every $shhf in wsdl:operation//wsoap12:*[local-name(.) = 'header' or local-name(.) = 'headerfault'] satisfies&#xA;      some $msguse in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[@name = $shhf/../../@name]/*[local-name(.) = local-name($shhf/..)]&#xA;      satisfies every $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = local-name-from-QName(resolve-QName(xsd:string($msguse/@message),$msguse))]/wsdl:part&#xA;      satisfies $mpart/@element or $shhf/@part and not($shhf/@part = $mpart/@name))&#xA;      and (every $sf in wsdl:operation/wsdl:fault/wsoap12:fault &#xA;      satisfies some $msguse in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[@name = $sf/../../@name]/wsdl:fault[@name = $sf/@name]&#xA;      satisfies every $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = local-name-from-QName(resolve-QName(xsd:string($msguse/@message),$msguse))]/wsdl:part&#xA;      satisfies $mpart/@element)&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The wsoap12:header, wsoap12:headerfault or
        wsoap12:fault elements refer to wsd:part element(s) that
        are not defined using only the "element" attribute.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding"
              priority="152114">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2114&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2114&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2114</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="some $bing in self::node() satisfies &#xA;      every $op in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType[local-name-from-QName(resolve-QName(xsd:string($bing/@type),$bing)) = @name]/wsdl:operation satisfies &#xA;      some $bop in $bing/wsdl:operation[@name = $op/@name] satisfies ( &#xA;      ( &#xA;      ($bop/wsdl:input/wsoap12:body[not(@parts)]) or &#xA;      ( every $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = local-name-from-QName(resolve-QName(xsd:string($op/wsdl:input/@message),$op/wsdl:input))]/wsdl:part satisfies &#xA;      (&#xA;      fn:exists(fn:index-of(tokenize($bop/wsdl:input/wsoap12:body/@parts,'\s+'), $mpart/@name)) or &#xA;      (some $extra in $bing/wsdl:operation/wsdl:*/wsoap12:*[local-name-from-QName(resolve-QName(xsd:string(@message),.)) = $mpart/../@name] satisfies $mpart/@name = $extra/@part ))&#xA;      ) &#xA;      ) &#xA;      and &#xA;      ( not($op/wsdl:output) or &#xA;      ($bop/wsdl:output/wsoap12:body[not(@parts)]) or &#xA;      ( every $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name =  local-name-from-QName(resolve-QName(xsd:string($op/wsdl:output/@message),$op/wsdl:output))]/wsdl:part satisfies &#xA;      ( &#xA;      fn:exists(fn:index-of(tokenize($bop/wsdl:output/wsoap12:body/@parts,'\s+'), $mpart/@name)) or &#xA;      (some $extra in $bing/wsdl:operation/wsdl:*/wsoap12:*[local-name-from-QName(resolve-QName(xsd:string(@message),.)) = $mpart/../@name] satisfies  &#xA;      $mpart/@name = $extra/@part )) &#xA;      ) &#xA;      ) &#xA;      and &#xA;      ( not($op/wsdl:fault) or &#xA;      (every $flt in $op/wsdl:fault satisfies $flt/@name = $bop/wsdl:fault/wsoap12:fault/@name) ) &#xA;      ) &#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A wsdl:binding does not bind every wsdl:part of a
        wsdl:message in the wsdl:portType to which it refers to
        one of wsoap12:body, wsoap12:header, wsoap12:fault or
        wsoap12:headerfault.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part/@element]"
              priority="152115">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2115&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2115&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2115</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="&#xA;        every $part in wsdl:part[@element] satisfies &#xA;        some $ged in //xsd:schema/xsd:element satisfies&#xA;        (&#xA;        ( &#xA;        $ged/../@targetNamespace  =   namespace-uri-from-QName( resolve-QName(xsd:string($part/@element),$part)) &#xA;        or &#xA;        (not ($ged/../@targetNamespace)  and not (namespace-uri-from-QName( resolve-QName(xsd:string($part/@element),$part)) ) )&#xA;        )&#xA;        and&#xA;        local-name-from-QName(resolve-QName(xsd:string($part/@element),$part)) = $ged/@name&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A wsdl:message element containing a wsdl:part element that
        uses the "element" attribute does not refer, via that
        attribute, to a global element declaration.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request'&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and  not (soap12:Body//soap12:Fault) ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1510120">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1012a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1012a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation[@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1012a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        some $mbody in ./soap12:Body satisfies&#xA;        some $dbody in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation[@name = fn:local-name($mbody/*[1])]/wsdl:input/wsoap12:body satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[@name = fn:local-name($mbody/*[1])]/*[fn:local-name(.) = 'input'] satisfies&#xA;        some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = fn:tokenize(xsd:string($dopmsg/@message), ':' )[fn:last()]] satisfies&#xA;        ( not(wsdl:part) and not($mbody/*/* )) or &#xA;        (every $tst in&#xA;        ( for $i in 1 to fn:count($mbody/*/*) return&#xA;        //wsdl:message/wsdl:part[not($dbody/@parts and not(fn:contains($dbody/@parts,@name)))][$i]/@name = &#xA;        fn:local-name($mbody/*/*[$i])&#xA;        )&#xA;        satisfies $tst = fn:true())&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The content of the request message 
        envelope does not match the
        wsdl:message definition for rpc/lit binding.
        The order of parts in soap12:Body
        does not match the order of wsdl:partS in wsdl:message
        that describes it for each of the wsdl:part elements bound
        to the envelope's corresponding wsoap12:body element.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and not (soap12:Body/soap12:Fault)]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1510121">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1012b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1012b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]/&#xA;        wsdl:operation&#xA;        [fn:string-join((@name, 'Response' ),'' ) = fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1012b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        some $mbody in ./soap12:Body satisfies&#xA;        some $dbody in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation[fn:string-join((@name, 'Response'),'')  = fn:local-name($mbody/*[1])]/wsdl:output/wsoap12:body satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[fn:string-join((@name, 'Response'),'') = fn:local-name($mbody/*[1])]/*[fn:local-name(.) = 'output' ] satisfies&#xA;        some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = fn:tokenize(xsd:string($dopmsg/@message), ':' )[fn:last()] and wsdl:part/@type] satisfies&#xA;        every $tst in&#xA;        ( for $i in 1 to fn:count($mbody/*/*) return&#xA;        //wsdl:message/wsdl:part[not($dbody/@parts and not(fn:contains($dbody/@parts,@name)))][$i]/@name = &#xA;        fn:local-name($mbody/*/*[$i])&#xA;        )&#xA;        satisfies $tst = fn:true()&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The content of the response message 
        envelope does not match the
        wsdl:message definition for rpc/lit binding.
        The order of parts in soap12:Body
        does not match the order of wsdl:partS in wsdl:message
        that describes it for each of the wsdl:part elements bound
        to the envelope's corresponding wsoap12:body element.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation&#xA;      "
              priority="152208">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2208&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2208&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2703=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2703&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2208</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2703</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="not(*[local-name-from-QName(node-name(.)) = 'output' and position() = 1])">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        wsdl:operation was not a request/response or one-way
        operation.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType&#xA;      "
              priority="152010">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2010&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2010&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2703=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2703&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2010</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2703</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="&#xA;        not(wsdl:operation[@name = preceding-sibling::*/@name]) and &#xA;        not(wsdl:operation[@name = following-sibling::*/@name])&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        name attributes are not unique within the portType
        definition.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog//wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[@parameterOrder]&#xA;      "
              priority="152014">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2014&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2014&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2014</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="for $op in self::node() return&#xA;      count( for $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/*/wsdl:message[@name = $op/wsdl:output/@message]/wsdl:part &#xA;      return index-of(tokenize($op/@parameterOrder,'\s+'), $mpart/@name)) ge &#xA;      count(/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/*/wsdl:message[@name = $op/wsdl:output/@message]/wsdl:part) - 1">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An operation associated with an rpc-literal binding has a
        parameterOrder attribute that omits more than 1 part.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part]"
              priority="152116">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2116&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2116&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2116</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(wsdl:part[@type and @element])">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A wsdl:message element has at least one wsdl:part element
        that contains both type and element attributes.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding"
              priority="152402">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2402&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2402&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2703=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2703&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2402</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2703</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="child::wsoap12:binding">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The wsdl:binding element does not use a wsoap12:binding
        element as defined in section "3 SOAP Binding." of the
        WSDL 1.1 specification.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[wsoap12:binding]"
              priority="152403">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2403&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2403&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2703=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2703&#34;][1]/@result, &#34;;&#34; ,&#34;BP2402=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2402&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2403</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2703</xsl:text>
                           </xsl:element>
                        </xsl:if>
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2402&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2402&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2402</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="wsoap12:binding[@transport]">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Transport attribute of the soabinding does not exist.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[wsoap12:binding]"
              priority="152404">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2404&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2404&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2703=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2703&#34;][1]/@result, &#34;;&#34; ,&#34;BP2402=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2402&#34;][1]/@result, &#34;;&#34; ,&#34;BP2403=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2403&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2404</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2703</xsl:text>
                           </xsl:element>
                        </xsl:if>
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2402&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2402&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2402</xsl:text>
                           </xsl:element>
                        </xsl:if>
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2403&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2403&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2403</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="wsoap12:binding[@transport='http://schemas.xmlsoap.org/soap/http']">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Transport attribute of the soabinding does not contain
        http://schemas.xmlsoap.org/soap/http.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[wsoap12:binding]"
              priority="152017">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2017&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2017&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2404=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2404&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2017</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2404&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2404&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2404</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="not(.//wsoap12:body/@use != 'literal')&#xA;      and (count(.//wsoap12:body) = count(.//wsoap12:body/@use)) and &#xA;      ((not(.//wsoap12:*/@style != 'rpc') and not(.//wsoap12:operation[not(@style) and not(../../wsoap12:binding/@style)])) or (not(.//wsoap12:*/@style != 'document')))&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The "style" attribute of an operation in soabinding,
        does not have the same value of "document" or "rpc", as
        other operations of the binding.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[wsoap12:binding]&#xA;      "
              priority="152406">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2406&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2406&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2703=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2703&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2406</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2703</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="not(.//*[@use and @use != &#34;literal&#34;])">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The use attribute of a wsoap12:body, wsoap12:fault,
        wsoap12:header and wsoap12:headerfault does not have
        value of "literal".
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile[wsdl:definitions]&#xA;      "
              priority="152705">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2705&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2705&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_metadata" select="$mytarget/@schemaValid[1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2705</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_metadata))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        $mytarget/@schemaValid = fn:true()&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The description file contains a WSDL definition which does not 
        conform to the schema located at 
        http://ws-i.org/profiles/basic/1.1/wsdl-2004-08-24.xsd
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]&#xA;      "
              priority="1521201">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2120b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2120b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_imagesig"
                    select="&#xA;        for $bop_1 in $mytarget/wsdl:operation return&#xA;        fn:string-join( &#xA;        (  $bop_1/wsdl:input/wsoap12:body/@namespace ,&#xA;        $bop_1/@name ,&#xA;        for $opmsg in  /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType&#xA;        [@name = fn:tokenize(xsd:string($mytarget/@type), ':' )[fn:last()]]/wsdl:operation[@name = $bop_1/@name]/&#xA;        wsdl:input return (  &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )&#xA;        )&#xA;        ),',' )&#xA;      [1]"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2017=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2017&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2120b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2017</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_imagesig))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        fn:count($cotarget_imagesig) = fn:count(fn:distinct-values($cotarget_imagesig))&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A binding has operations that are not unique.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [not(.//wsoap12:*[@style = 'rpc'])]&#xA;      "
              priority="1521200">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2120a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2120a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_imagesig"
                    select="&#xA;        for $bop_1 in $mytarget/wsdl:operation return&#xA;        fn:string-join( &#xA;        (  for $part in &#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [&#xA;        @name = ( fn:tokenize(/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType&#xA;        [@name = fn:tokenize(xsd:string($mytarget/@type), ':' )[fn:last()]]/wsdl:operation[@name = $bop_1/@name]/&#xA;        wsdl:input/@message, ':' )[fn:last()]  )&#xA;        ]/wsdl:part[1]&#xA;        return (fn:namespace-uri-from-QName(fn:resolve-QName(xsd:string($part/@element), $part)) ,  fn:local-name-from-QName(fn:resolve-QName(xsd:string($part/@element), $part)) ) ,&#xA;        for $opmsg in  /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType&#xA;        [@name = fn:tokenize(xsd:string($mytarget/@type), ':' )[fn:last()]]/wsdl:operation[@name = $bop_1/@name]/&#xA;        wsdl:input return (  &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )&#xA;        )&#xA;        ),',' )&#xA;      [1]"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2017=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2017&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2120a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2017</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_imagesig))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        fn:count($cotarget_imagesig) = fn:count(fn:distinct-values($cotarget_imagesig))&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A binding has operations that are not unique.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request'&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body[not (soap12:Fault)]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1510110">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1011a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1011a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1011a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="count(soap12:Body/*) le 1">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The content of the envelope associated with a doc-lit WSDL binding 
        does not match the wsdl:message definition. 
        the child element of soap12:body is not an instance of the
        global element declaration referenced by the corresponding
        wsdl:part.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body[not (soap12:Fault)]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1510111">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1011b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1011b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Response' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1011b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="count(soap12:Body/*) le 1">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The content of the envelope does not match the
        wsdl:message definition. 
        the child element of soap12:Body is not an instance of the
        global element declaration referenced by the corresponding
        wsdl:part.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request'&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body[not (soap12:Fault)]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1511110">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1111a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1111a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1111a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        some $myOpBind in $cotarget_myOpBinding satisfies&#xA;        (&#xA;        not($myOpBind/..//wsoap12:body/@use != 'literal') &#xA;        and (count($myOpBind/..//wsoap12:body) = count($myOpBind/..//wsoap12:body/@use))  and&#xA;        $myOpBind/../wsoap12:binding[ not (@style = 'rpc' )] and&#xA;        $myOpBind/wsoap12:operation[ not (@style = 'rpc' )] &#xA;        )&#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="count(soap12:Body/*) le 1">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The content of the request message envelope associated with a doc-lit WSDL binding 
        does not match the wsdl:message definition. 
        the child element of soap12:body is not an instance of the
        global element declaration referenced by the corresponding
        wsdl:part.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body[not (soap12:Fault)]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1511111">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1111b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1111b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Response' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1111b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        some $myOpBind in $cotarget_myOpBinding satisfies&#xA;        (&#xA;        not($myOpBind/..//wsoap12:body/@use != 'literal') &#xA;        and (count($myOpBind/..//wsoap12:body) = count($myOpBind/..//wsoap12:body/@use))  and&#xA;        $myOpBind/../wsoap12:binding[ not (@style = 'rpc' )] and&#xA;        $myOpBind/wsoap12:operation[ not (@style = 'rpc' )] &#xA;        )&#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="count(soap12:Body/*) le 1">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The content of the response message envelope does not match the
        wsdl:message definition. 
        the child element of soap12:Body is not an instance of the
        global element declaration referenced by the corresponding
        wsdl:part.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[not(.//wsoap12:*[@style = 'rpc'])]&#xA;      "
              priority="152019">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2019&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2019&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2406=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2406&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2019</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2406&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2406&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2406</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test=" &#xA;        every $wopbind in ( $mytarget//wsoap12:body | $mytarget//wsoap12:fault | $mytarget//wsoap12:header | $mytarget//wsoap12:headerfault )&#xA;        satisfies   not($wopbind/@namespace)&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The binding is of style "document" and use "literal", and
        the "namespace" attribute is specified in some
        wsoap12:body, wsoap12:header, wsoap12::headerfault,
        wsoap12:fault element
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]&#xA;      "
              priority="152020">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2020&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2020&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2017=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2017&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2020</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2017</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="every $wbody in .//wsoap12:body satisfies fn:count(fn:tokenize($wbody/@namespace,':')) &gt; 1">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A wsoap12:body element does not have a namespace
        attribute, or the namespace attribute value is not an
        absolute URI.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]&#xA;      "
              priority="152117">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2117&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2117&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2017=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2017&#34;][1]/@result, &#34;;&#34; ,&#34;BP2406=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2406&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2117</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2017&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2017</xsl:text>
                           </xsl:element>
                        </xsl:if>
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2406&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2406&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2406</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="not(.//wsoap12:fault[@namespace]) and not(.//wsoap12:header[@namespace]) and not(.//wsoap12:headerfault[@namespace])">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        An rpc-literal binding has the namespace attribute
        specified on contained wsoap12:header,
        wsoap12:headerfault and wsoap12:fault elements.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding"
              priority="152118">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2118&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2118&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myportype"
                    select="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType[@name = fn:local-name-from-QName(fn:resolve-QName(xsd:string($mytarget/@type), $mytarget))][1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2118</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myportype))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (every $operation in $cotarget_myportype/wsdl:operation satisfies  &#xA;        (some $bop in $mytarget/wsdl:operation satisfies  &#xA;        $bop/@name = $operation/@name)) and &#xA;        (count(wsdl:operation) = count($cotarget_myportype/wsdl:operation)) and &#xA;        not(wsdl:operation[@name = preceding-sibling::wsdl:operation/@name  ]) &#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A wsdl:binding does not have the same list of
        wsdl:operations as the wsdl:portType to which it refers.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation[wsdl:input/wsoap12:header or wsdl:input/wsoap12:headerfault or wsdl:output/wsoap12:header or  wsdl:output/wsoap12:headerfault]&#xA;      "
              priority="152021">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2021&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2021&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP2703=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP2703&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2021</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP2703&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP2703</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="&#xA;        (not(wsdl:input/wsoap12:header) or (wsdl:input/wsoap12:header[@part] and not(wsdl:input/wsoap12:header[@parts]) and&#xA;        not(wsdl:input/wsoap12:header[contains(@part, ' ')]) and not(wsdl:input/wsoap12:header[contains(@part, ',')]))) and &#xA;        (not(wsdl:input/wsoap12:headerfault) or (wsdl:input/wsoap12:headerfault[@part] and not(wsdl:input/wsoap12:headerfault[@parts]) and&#xA;        not(wsdl:input/wsoap12:headerfault[contains(@part, ' ')]) and not(wsdl:input/wsoap12:headerfault[contains(@part, ',')]))) and &#xA;        (not(wsdl:output/wsoap12:header) or (wsdl:output/wsoap12:header[@part] and not(wsdl:output/wsoap12:header[@parts]) and &#xA;        not(wsdl:output/wsoap12:header[contains(@part, ' ')]) and not(wsdl:output/wsoap12:header[contains(@part, ',')]))) and &#xA;        (not(wsdl:output/wsoap12:headerfault) or (wsdl:output/wsoap12:headerfault[@part] and not(wsdl:output/wsoap12:headerfault[@parts]) and&#xA;        not(wsdl:output/wsoap12:headerfault[contains(@part, ' ')]) and not(wsdl:output/wsoap12:headerfault[contains(@part, ',')]))) &#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The wsdl:input element or wsdl:output element of an
        operation does not use the attribute name "part" with a
        Schema type of "NMTOKEN" for wsoap12:header elements or
        wsoap12:headerfault elements, or it uses "parts".
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation/wsdl:fault/wsoap12:fault"
              priority="152022">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2022&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2022&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2022</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="@name and @name != '' ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Defective wsoap12:fault element: the name attribute is
        not specified on the wsoap12:fault element.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation/wsdl:fault"
              priority="152032">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2032&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2032&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2032</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="@name = wsoap12:fault/@name">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Defective wsoap12:fault element: the "name" attribute
        value does not match the value of the "name" attribute on
        the parent element wsdl:fault.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/&#xA;        soap12:Envelope[soap12:Body/* and not (soap12:Body/soap12:Fault)]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="151005">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1005&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1005&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_related-Request"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [ @type = 'request' and &#xA;&#x9;(if (not(./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:MessageID) ) then (&#xA;        @conversation = $mytarget/../../@conversation) else &#xA;        (./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo&#xA;        [@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]&#xA;        ))&#xA;        ]/wsil:messageContents/soap12:Envelope[soap12:Body/*]&#xA;      [1]"/>
      <xsl:variable name="cotarget_myOpBindings"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*&#xA;        [@style = 'rpc']]/wsdl:operation[@name =   fn:local-name($cotarget_related-Request[1]/soap12:Body/*[1])]     &#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1005</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_related-Request))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_myOpBindings))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        fn:concat(fn:local-name($cotarget_related-Request[1]/soap12:Body/*[1]), 'Response' ) = &#xA;        fn:local-name($mytarget/soap12:Body/*[1])&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Wrapper element in the envelope does not have a value
        equal to the name attribute on the wsdl:operation element
        suffixed with string "Response".
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request'&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and  not (soap12:Body//soap12:Fault) ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1510080">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1008a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1008a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation[@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1008a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        every $accessor in $mytarget/soap12:Body/*/* satisfies&#xA;        ( fn:namespace-uri-from-QName(fn:node-name($accessor)) = ''  or fn:namespace-uri-from-QName(fn:node-name($accessor)) = 'http://www.ws-i.org/testing/2008/02/log/')&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The request envelope has part accessor elements for  parameters and
        return value, within namespaces.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message &#xA;        [@type = 'response' &#xA;        or  &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and not (soap12:Body/soap12:Fault)]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1510081">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1008b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1008b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]/ &#xA;        wsdl:operation  &#xA;        [fn:string-join((@name, 'Response' ),'' ) = fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1008b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        every $accessor in ./soap12:Body/*/* satisfies&#xA;        ( fn:namespace-uri-from-QName(fn:node-name($accessor)) = ''  or fn:namespace-uri-from-QName(fn:node-name($accessor)) = 'http://www.ws-i.org/testing/2008/02/log/' )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The response envelope has part accessor elements for parameters and
        return value, within namespaces.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request'&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and  not (soap12:Body//soap12:Fault) ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1517550">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1755a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1755a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation[@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1755a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (some $mbody in ./soap12:Body satisfies&#xA;        every $accessor in $mbody/*/* satisfies&#xA;        some $dbody in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [@name = fn:local-name($mbody/*[1])]/wsdl:input/wsoap12:body satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation&#xA;        [@name = fn:local-name($mbody/*[1])]/*[fn:local-name(.) = 'input' ] satisfies&#xA;        some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [@name = fn:tokenize(xsd:string($dopmsg/@message),':' )[fn:last() ] ]satisfies&#xA;        some $mpart in $dmesg/wsdl:part satisfies&#xA;        $mpart/@name = fn:local-name($accessor)&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The envelope referenced by an rpc-literal binding has a
        part accessor element with a local name that is not the
        same value as the name attribute of the corresponding
        wsdl:part element.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and not (soap12:Body/soap12:Fault)]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1517551">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1755b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1755b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]/&#xA;        wsdl:operation&#xA;        [fn:string-join((@name, 'Response' ),'' ) = fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1755b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (some $mbody in ./soap12:Body satisfies&#xA;        every $accessor in $mbody/*/* satisfies&#xA;        some $dbody in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation[fn:string-join((@name, 'Response' ),'')  = fn:local-name($mbody/*[1])]/wsdl:output/wsoap12:body satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[fn:string-join((@name, 'Response'),'') = fn:local-name($mbody/*[1])]/*[fn:local-name(.) = 'output' ] satisfies&#xA;        some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[@name = fn:tokenize(xsd:string($dopmsg/@message),':' )[fn:last() ] ] satisfies&#xA;        some $mpart in $dmesg/wsdl:part satisfies&#xA;        $mpart/@name = fn:local-name($accessor)&#xA;        ) &#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The response envelope referenced by an rpc-literal binding has a
        part accessor element with a local name that is not the
        same value as the name attribute of the corresponding
        wsdl:part element.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request'&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body[not (soap12:Fault)]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1510090">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1009a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1009a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1009a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( $cotarget_myOpBinding/wsdl:input/wsoap12:header&#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        some $myOpBind in $cotarget_myOpBinding satisfies&#xA;        (&#xA;        every $inputhdr in $myOpBind/wsdl:input/wsoap12:header satisfies&#xA;        some $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [@name = fn:local-name-from-QName(fn:resolve-QName(xsd:string($inputhdr/@message), $inputhdr)) ]&#xA;        /wsdl:part[ @name  = $inputhdr/@part] &#xA;        satisfies  &#xA;        some $headerblk in $mytarget/soap12:Header/* satisfies&#xA;        ( fn:resolve-QName(xsd:string($mpart/@element), $mpart ) = fn:node-name($headerblk) )&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Envelope does not include all wsoap12:headers specified
        in the wsdl:input (of request) of its bound operation.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body[not (soap12:Fault)]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1510091">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1009b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1009b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message[wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:output satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Response' )  )&#xA;        )   &#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1009b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        $cotarget_myOpBinding/wsdl:output/wsoap12:header&#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        some $myOpBind in $cotarget_myOpBinding satisfies&#xA;        (&#xA;        every $outputhdr in $myOpBind/wsdl:output/wsoap12:header satisfies&#xA;        some $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [@name = fn:local-name-from-QName(fn:resolve-QName(xsd:string($outputhdr/@message), $outputhdr)) ]&#xA;        /wsdl:part[ @name  = $outputhdr/@part] &#xA;        satisfies  &#xA;        some $headerblk in $mytarget/soap12:Header/* satisfies&#xA;        ( fn:resolve-QName(xsd:string($mpart/@element), $mpart ) = fn:node-name($headerblk) )&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Envelope does not include all wsoap12:headers specified
        in the wsdl:input (if request) or wsdl:output (if
        response) of its bound operation.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request' &#xA;        and &#xA;        not (./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and not (soap12:Body//soap12:Fault)]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1510092">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1009c&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1009c&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]/&#xA;        wsdl:operation[@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1009c</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        $cotarget_myOpBinding/wsdl:input/wsoap12:header&#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        some $myOpBind in $cotarget_myOpBinding satisfies&#xA;        (&#xA;        every $inputhdr in $myOpBind/wsdl:input/wsoap12:header satisfies&#xA;        some $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [@name = fn:local-name-from-QName(fn:resolve-QName(xsd:string($inputhdr/@message), $inputhdr)) ]&#xA;        /wsdl:part[ @name  = $inputhdr/@part] &#xA;        satisfies  &#xA;        some $headerblk in $mytarget/soap12:Header/* satisfies&#xA;        ( fn:resolve-QName(xsd:string($mpart/@element), $mpart ) = fn:node-name($headerblk) )&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Envelope does not include all wsoap12:headers specified
        in the wsdl:input (if request) or wsdl:output (if
        response) of its bound operation.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response'&#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and  not (soap12:Body//soap12:Fault) ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1510093">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1009d&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1009d&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation&#xA;        [fn:string-join((@name, 'Response' ),'' ) = fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1009d</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not( &#xA;        $cotarget_myOpBinding/wsdl:output/wsoap12:header&#xA;      )">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        some $myOpBind in $cotarget_myOpBinding satisfies&#xA;        (&#xA;        every $outputhdr in $myOpBind/wsdl:output/wsoap12:header satisfies&#xA;        some $mpart in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [@name = fn:local-name-from-QName(fn:resolve-QName(xsd:string($outputhdr/@message), $outputhdr)) ]&#xA;        /wsdl:part[ @name  = $outputhdr/@part] &#xA;        satisfies  &#xA;        some $headerblk in $mytarget/soap12:Header/* satisfies&#xA;        ( fn:resolve-QName(xsd:string($mpart/@element), $mpart ) = fn:node-name($headerblk) )&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Envelope does not include all wsoap12:headers specified
        in the wsdl:input (if request) or wsdl:output (if
        response) of its bound operation.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'action']&#xA;        (: and @type = 'request' :)&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body[not (soap12:Fault)]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1511160">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1116a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1116a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($mytarget/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($mytarget/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($mytarget/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )    &#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP1006=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP1006&#34;][1]/@result, &#34;;&#34; ,&#34;BP1761=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP1761&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1116a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP1006&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP1006&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP1006</xsl:text>
                           </xsl:element>
                        </xsl:if>
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP1761&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP1761&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP1761</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        some $myOpBind in $cotarget_myOpBinding satisfies&#xA;        (&#xA;        ($myOpBind/wsoap12:operation/@soapAction = $mytarget/../../wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter&#xA;        [fn:lower-case(@key) = 'action']/@value) or (not ($myOpBind/wsoap12:operation/@soapAction ) and &#xA;        $mytarget/../../wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'action']/@value = '') &#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The action parameter on the Content-Type header if present
        does not match wsoap12:operation/@soapAction attribute. 
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'action']&#xA;        (: and @type = 'request' :)&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and  not (soap12:Body//soap12:Fault) ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1511161">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1116b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1116b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation[@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:variable name="prereqres">
         <xsl:value-of select="concat(&#34;BP1006=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP1006&#34;][1]/@result, &#34;;&#34; ,&#34;BP1761=&#34;,$tempresults//*:test[@id eq $logentry  or (fn:contains($logentry, &#34;:&#34;) and fn:starts-with($logentry, @id))][@tassertion eq &#34;BP1761&#34;][1]/@result, &#34;;&#34; )"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="not(contains($prereqres, '=;'))">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1116b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="contains($prereqres, '=false') or contains($prereqres, '=notrelvt')">
                     <xsl:attribute name="result">notrelvt</xsl:attribute>
                     <xsl:element name="wsi-rep:prereqFailedList">
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP1006&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP1006&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP1006</xsl:text>
                           </xsl:element>
                        </xsl:if>
                        <xsl:if test="fn:starts-with(fn:substring-after($prereqres, &#34;BP1761&#34;), &#34;=false&#34;) or fn:starts-with(fn:substring-after($prereqres, &#34;BP1761&#34;), &#34;=notrelvt&#34;)">
                           <xsl:element name="wsi-rep:testAssertionID">
                              <xsl:text>BP1761</xsl:text>
                           </xsl:element>
                        </xsl:if>
                     </xsl:element>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        some $myOpBind in $cotarget_myOpBinding satisfies&#xA;        (&#xA;        ($myOpBind/wsoap12:operation/@soapAction = $mytarget/../../wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter&#xA;        [fn:lower-case(@key) = 'action']/@value) or (not ($myOpBind/wsoap12:operation/@soapAction ) and &#xA;        $mytarget/../../wsil:httpHeaders/wsil:contentTypeHeader/wsil:parameter[fn:lower-case(@key) = 'action']/@value = '') &#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The action parameter on the Content-Type header if present
        does not match wsoap12:operation/@soapAction attribute. 
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile[wsdl:definitions//xsd:schema]&#xA;      "
              priority="152122">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2122&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2122&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_metadata" select="$mytarget/@schemaValid[1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2122</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_metadata))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        $mytarget/@schemaValid = fn:true()&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A wsdl:types element contained a data type definition that
        is not an XML schema definition.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/soap12:Fault and soap12:Header[wsa:Action]]&#xA;        [&#xA;        some $myenv in .&#xA;        satisfies&#xA;        (  every $message in //wsdl:definitions/wsdl:message satisfies ( (not($message/wsdl:part[1]/@type)  )&#xA;        and ( $myenv/soap12:Body/*[1] or $myenv/soap12:Header/wsa:Action ))&#xA;        ) &#xA;        ]&#xA;      "
              priority="1510900">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1090a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1090a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_relatedRequest"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/&#xA;        wsil:messageContents/soap12:Envelope[soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)]   ][1]&#xA;      [1]"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation&#xA;        [&#xA;        some $opBinding in . satisfies &#xA;        (if ($cotarget_relatedRequest/soap12:Body/*[1] ) then&#xA;        (some $dmesg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [wsdl:part[fn:resolve-QName(xsd:string(@element), . ) = fn:node-name($cotarget_relatedRequest[1]/soap12:Body/*[1])] ]&#xA;        satisfies&#xA;        some $dopmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input&#xA;        [fn:local-name-from-QName(fn:resolve-QName(xsd:string(@message), . )) = $dmesg/@name] &#xA;        satisfies&#xA;        $opBinding/@name = $dopmsg/../@name&#xA;        ) else fn:true()&#xA;        )   and&#xA;        ( if ($cotarget_relatedRequest/soap12:Header/wsa:Action) then&#xA;        (  some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation/wsdl:input satisfies&#xA;        ($cotarget_relatedRequest/soap12:Header/wsa:Action =     &#xA;        (    if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, &#xA;&#x9;'/',&#xA;        if($opmsg/@name) then $opmsg/@name&#xA;        else fn:concat($opmsg/../@name, 'Request' )  )&#xA;        )&#xA;        )  and ( $opBinding/@name = $opmsg/../@name  )  )&#xA;        else fn:true()&#xA;        )&#xA;        ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1090a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_relatedRequest))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test=" &#xA;        (: correct wsa:Action value :)&#xA;        not(/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[ $cotarget_myOpBinding/@name = @name ]/wsdl:fault)&#xA;        or&#xA;        (some $detailQName in fn:node-name($mytarget/soap12:Body/soap12:Fault/soap12:Detail/*[1]) &#xA;        satisfies&#xA;        some $msgDef in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [ wsdl:part[1][fn:resolve-QName(xsd:string(@element),.) = $detailQName  ]]  &#xA;        satisfies&#xA;        (some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[ $cotarget_myOpBinding/@name = @name ] satisfies&#xA;        (not&#xA;        ($opmsg/wsdl:fault[ fn:local-name-from-QName(fn:resolve-QName(xsd:string(./@message),.)) = $msgDef/@name ])&#xA;        or&#xA;        (some $flt in $opmsg/wsdl:fault[ fn:local-name-from-QName(fn:resolve-QName(xsd:string(./@message),.)) = $msgDef/@name ]&#xA;        satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        ( if ($flt/@wsam:Action) then $flt/@wsam:Action&#xA;        else fn:concat($opmsg/../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../@name, '/', $opmsg/@name, '/Fault/', $flt/@name )&#xA;&#x9;)&#xA;        ) )) &#xA;        ))&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A Fault response message defined using a doc/lit binding has a wsa:Action value that is not
        equal to that specified in the WSDL. This may be due to the fact that the fault was
        generated by some infrastructure component (e.g. WS-Addressing, WS-RM, etc.). Verify that
        the fault was generated by some WS-* infrastructure component and not by the application.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[ (soap12:Body/soap12:Fault) and soap12:Header[wsa:Action]]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1510901">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1090b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1090b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_relatedRequest"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/&#xA;        wsil:messageContents/soap12:Envelope[soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] ][1]  &#xA;      [1]"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation[@name =  fn:local-name-from-QName(node-name($cotarget_relatedRequest[1]/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1090b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_relatedRequest))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test=" &#xA;        (: correct wsa:Action value :)&#xA;        some $detailQName in fn:node-name($mytarget/soap12:Body/soap12:Fault/soap12:Detail/*[1]) &#xA;        satisfies&#xA;        some $msgDef in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:message&#xA;        [ wsdl:part[1][fn:resolve-QName(xsd:string(@element),.) = $detailQName  ]]  &#xA;        satisfies&#xA;        (some $opmsg in /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/&#xA;        wsdl:operation[ $cotarget_myOpBinding/@name = @name ]/&#xA;        wsdl:fault[ fn:local-name-from-QName(fn:resolve-QName(xsd:string(./@message),.)) = $msgDef/@name ] &#xA;        satisfies&#xA;        ($mytarget/soap12:Header/wsa:Action =     &#xA;        ( if ($opmsg/@wsam:Action) then $opmsg/@wsam:Action&#xA;        else &#xA;&#x9;fn:concat($opmsg/../../../@targetNamespace,&#xA;&#x9;if (not(fn:ends-with($opmsg/../../../@targetNamespace,'/'))) then '/' else '',&#xA;&#x9;$opmsg/../../@name, '/', $opmsg/../@name, '/Fault/', $opmsg/@name )&#xA;        ) ) &#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        A Fault response message defined using a rpc/lit binding has a wsa:Action value that is not
        equal to that specified in the WSDL. This may be due to the fact that the fault was
        generated by some infrastructure component (e.g. WS-Addressing, WS-RM, etc.). Verify that
        the fault was generated by some WS-* infrastructure component and not by the application.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding/wsdl:operation[wsoap12:operation[@soapAction] and &#xA;&#x9;wsoap12:operation/@soapAction ne '' and&#xA;&#x9;(some $bop in . satisfies&#xA;&#x9;/wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[@name = $bop/@name]/wsdl:input[@wsam:Action])]&#xA;      "
              priority="152801">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP2801&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP2801&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpDefinition"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:portType/wsdl:operation[@name = $mytarget/@name] &#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP2801</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpDefinition))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        $mytarget/wsoap12:operation/@soapAction = &#xA;           $cotarget_myOpDefinition/wsdl:input/@wsam:Action&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The value of wsam:Action attribute for the wsdl:input element contained in the target wsdl:operation of the wsdl portType, does not match the @soapAction value in this operation binding. 
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'request'&#xA;        and &#xA;        not ( ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ] )&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and  not (soap12:Body//soap12:Fault) ]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1512110">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1211a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1211a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding&#xA;        [.//wsoap12:*[@style = 'rpc']]/wsdl:operation[@name =  fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1211a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not (soap12:Body/*/*[attribute::xsi:nil = '1' or attribute::xsi:nil = fn:true()])">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        Envelope referenced by an rpc-literal binding has part
        accessor elements with an xsi:nil attribute with a value
        of "1" or "true".
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;        [@type = 'response' &#xA;        or &#xA;        ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;        [not (@RelationshipType) or ( @RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' ) ]&#xA;        ]&#xA;        /wsil:messageContents/soap12:Envelope[soap12:Body/* and not (soap12:Body/soap12:Fault)]&#xA;        [&#xA;        some $myenv in . satisfies&#xA;        some $message in //wsdl:definitions/wsdl:message satisfies ($message/wsdl:part[1]/@type)&#xA;        ]&#xA;      "
              priority="1512111">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1211b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1211b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_myOpBinding"
                    select="&#xA;        /wsil:testLog/wsil:descriptionFiles/wsil:descriptionFile/wsdl:definitions/wsdl:binding[.//wsoap12:*[@style = 'rpc']]/&#xA;        wsdl:operation&#xA;        [fn:string-join((@name, 'Response' ),'' ) = fn:local-name-from-QName(node-name($mytarget/soap12:Body/*[1]))]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1211b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_myOpBinding))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="not (soap12:Body/*/*[attribute::xsi:nil = '1' or attribute::xsi:nil = fn:true()])">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        response Envelope referenced by an rpc-literal binding has part
        accessor elements with an xsi:nil attribute with a value
        of "1" or "true".
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;          [@type = 'response' or&#xA;            ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;            [not (@RelationshipType) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply')]&#xA;          ]&#xA;        /wsil:messageContents/soap12:Envelope&#xA;          [/wsil:testLog/wsil:descriptionFiles/wsil:feature[@name=&#34;http://www.w3.org/ns/ws-policy/Policy&#34;]/wsil:alternative/wsil:feature[@name=&#34;http://www.w3.org/2007/05/addressing/metadata/Addressing&#34;]/wsil:alternative/wsil:feature[@name=&#34;http://www.w3.org/2007/05/addressing/metadata/AnonymousResponses&#34; and @mode=&#34;required&#34;]&#xA;        ]&#xA;      "
              priority="1511490">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1149a&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1149a&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_related-Request"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/&#xA;        wsil:messageContents/soap12:Envelope[soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1149a</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_related-Request))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (&#xA;        if&#xA;        (&#xA;          ($cotarget_related-Request/soap12:Header/wsa:ReplyTo and not ($cotarget_related-Request/soap12:Header/wsa:ReplyTo/wsa:Address = 'http://www.w3.org/2005/08/addressing/anonymous')) or&#xA;          ($cotarget_related-Request/soap12:Header/wsa:FaultTo and not ($cotarget_related-Request/soap12:Header/wsa:FaultTo/wsa:Address = 'http://www.w3.org/2005/08/addressing/anonymous'))&#xA;        )&#xA;        then&#xA;        (&#xA;          &#xA;          not ($mytarget/soap12:Body/soap12:Fault) or&#xA;          (&#xA;            fn:ends-with($mytarget/soap12:Body/soap12:Fault/soap12:Code/soap12:Value, 'Sender') and&#xA;            fn:ends-with($mytarget/soap12:Body/soap12:Fault/soap12:Code/soap12:Subcode/soap12:Value, 'InvalidAddressingHeader') and&#xA;            fn:ends-with($mytarget/soap12:Body/soap12:Fault/soap12:Code/soap12:Subcode/soap12:Subcode/soap12:Value, 'OnlyAnonymousAddressSupported')&#xA;          )&#xA;        )&#xA;        else fn:true()&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The service requires the use of WS-Addressing with anonymous response EPRs. The response to
        a request with non-anonymous response EPRs must be the fault defined by Section 6.4.1.7 of
        the "WS-Addressing 1.0 - SOAP Binding" specification. Altough the transmitted response is a
        fault, it does not match the definition in Section 6.4.1.7. This could be due to some
        other, overriding error such as a MustUnderstand fault. Inspect the response message and
        verify that this is the case. If not, the service is acting incorrectly by not
        transimitting the proper fault.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;          [@type = 'response' or&#xA;            ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;            [not (@RelationshipType) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply')]&#xA;          ]&#xA;        /wsil:messageContents/soap12:Envelope&#xA;          [/wsil:testLog/wsil:descriptionFiles/wsil:feature[@name=&#34;http://www.w3.org/ns/ws-policy/Policy&#34;]/wsil:alternative/wsil:feature[@name=&#34;http://www.w3.org/2007/05/addressing/metadata/Addressing&#34;]/wsil:alternative/wsil:feature[@name=&#34;http://www.w3.org/2007/05/addressing/metadata/AnonymousResponses&#34; and @mode=&#34;required&#34;]&#xA;        ]&#xA;      "
              priority="1511491">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1149b&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1149b&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_related-Request"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/&#xA;        wsil:messageContents/soap12:Envelope[soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1149b</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_related-Request))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (&#xA;        if&#xA;        (&#xA;          ($cotarget_related-Request/soap12:Header/wsa:ReplyTo and not ($cotarget_related-Request/soap12:Header/wsa:ReplyTo/wsa:Address = 'http://www.w3.org/2005/08/addressing/anonymous')) or&#xA;          ($cotarget_related-Request/soap12:Header/wsa:FaultTo and not ($cotarget_related-Request/soap12:Header/wsa:FaultTo/wsa:Address = 'http://www.w3.org/2005/08/addressing/anonymous'))&#xA;        )&#xA;        then&#xA;        (&#xA;          $mytarget/soap12:Body/soap12:Fault&#xA;        )&#xA;        else fn:true()&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The service requires the use of WS-Addressing with anonymous response EPRs. Any response
        to a request with non-anonymous response EPRs must be the fault defined by Section 6.4.1.7
        of the "WS-Addressing 1.0 - SOAP Binding" specification. The transmitted response is either
        not a fault or does not match the definition of this fault.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;          [@type = 'response' or&#xA;            ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;            [not (@RelationshipType) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply')]&#xA;          ]&#xA;        /wsil:messageContents/soap12:Envelope&#xA;          [/wsil:testLog/wsil:descriptionFiles/wsil:feature[@name=&#34;http://www.w3.org/ns/ws-policy/Policy&#34;]/wsil:alternative/wsil:feature[@name=&#34;http://www.w3.org/2007/05/addressing/metadata/Addressing&#34;]/wsil:alternative/wsil:feature[@name=&#34;http://www.w3.org/2007/05/addressing/metadata/NonAnonymousResponses&#34; and @mode=&#34;required&#34;]&#xA;        ]&#xA;      "
              priority="1511492">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1149c&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1149c&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_related-Request"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/&#xA;        wsil:messageContents/soap12:Envelope[soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1149c</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_related-Request))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (&#xA;        if&#xA;        (&#xA;          not ($cotarget_related-Request/soap12:Header/wsa:ReplyTo) or &#xA;          $cotarget_related-Request/soap12:Header/wsa:ReplyTo/wsa:Address='http://www.w3.org/2005/08/addressing/anonymous' or&#xA;          $cotarget_related-Request/soap12:Header/wsa:FaultTo/wsa:Address='http://www.w3.org/2005/08/addressing/anonymous'&#xA;        )&#xA;        then&#xA;        (&#xA;          &#xA;          not ($mytarget/soap12:Body/soap12:Fault) or&#xA;          (&#xA;            fn:ends-with($mytarget/soap12:Body/soap12:Fault/soap12:Code/soap12:Value, 'Sender') and&#xA;            fn:ends-with($mytarget/soap12:Body/soap12:Fault/soap12:Code/soap12:Subcode/soap12:Value, 'InvalidAddressingHeader') and&#xA;            fn:ends-with($mytarget/soap12:Body/soap12:Fault/soap12:Code/soap12:Subcode/soap12:Subcode/soap12:Value, 'OnlyNonAnonymousAddressSupported')&#xA;          )&#xA;        )&#xA;        else fn:true()&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The service requires the use of WS-Addressing with non-anonymous response EPRs. The
        response to a request with anonymous response EPRs must be the fault defined by Section
        6.4.1.8 of the "WS-Addressing 1.0 - SOAP Binding" specification. Altough the transmitted
        response is a fault, it does not match the definition in Section 6.4.1.8. This could be due
        to some other, overriding error such as a MustUnderstand fault. Inspect the response
        message and verify that this is the case. If not, the service is acting incorrectly by not
        transimitting the proper fault.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="warning"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA"
              match="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message&#xA;          [@type = 'response' or&#xA;            ./wsil:messageContents/soap12:Envelope/soap12:Header/wsa:RelatesTo&#xA;            [not (@RelationshipType) or (@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply')]&#xA;          ]&#xA;        /wsil:messageContents/soap12:Envelope&#xA;          [/wsil:testLog/wsil:descriptionFiles/wsil:feature[@name=&#34;http://www.w3.org/ns/ws-policy/Policy&#34;]/wsil:alternative/wsil:feature[@name=&#34;http://www.w3.org/2007/05/addressing/metadata/Addressing&#34;]/wsil:alternative/wsil:feature[@name=&#34;http://www.w3.org/2007/05/addressing/metadata/NonAnonymousResponses&#34; and @mode=&#34;required&#34;]&#xA;        ]&#xA;      "
              priority="1511493">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
   <xsl:param name="taoutlist"/>
   <xsl:variable name="prescription">mandatory</xsl:variable>
   <xsl:variable name="entryid">
      <xsl:call-template name="idpick">
         <xsl:with-param name="target" select="$target"/>
      </xsl:call-template>
   </xsl:variable>
   <xsl:variable name="logentry">
      <xsl:value-of select="$entryid"/>
   </xsl:variable>
   <xsl:variable name="nopreviousres"
                 select="not($tempresults//*:test[@id eq $logentry][@tassertion eq &#34;BP1149d&#34;])"/>
   <xsl:variable name="newtaoutlist">
      <xsl:choose>
         <xsl:when test="$nopreviousres eq fn:true()">
            <xsl:value-of select="concat($taoutlist, &#34;BP1149d&#34;, &#34;;&#34;)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="$taoutlist"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:variable>
   <xsl:if test="$nopreviousres eq fn:true()">
      <xsl:variable name="mytarget" select="self::node()"/>
      <xsl:variable name="cotarget_related-Request"
                    select="&#xA;        /wsil:testLog/wsil:messageLog/wsil:message[@type = 'request']/&#xA;        wsil:messageContents/soap12:Envelope[soap12:Header/wsa:MessageID = &#xA;        $mytarget/soap12:Header/wsa:RelatesTo[@RelationshipType = 'http://www.w3.org/2005/08/addressing/reply' or not (@RelationshipType)] ]&#xA;      [1]"/>
      <xsl:choose>
         <xsl:when test="'true'">
            <xsl:element name="test">
               <xsl:attribute name="tassertion">BP1149d</xsl:attribute>
               <xsl:attribute name="prescription">
                  <xsl:value-of select="$prescription"/>
               </xsl:attribute>
               <xsl:attribute name="artifact">
                  <xsl:value-of select="$tgtype"/>
               </xsl:attribute>
               <xsl:attribute name="target">
                  <xsl:value-of select="$target"/>
               </xsl:attribute>
               <xsl:attribute name="id">
                  <xsl:value-of select="$logentry"/>
               </xsl:attribute>
               <xsl:choose>
                  <xsl:when test="not(fn:exists($cotarget_related-Request))">
                     <xsl:attribute name="result">misinput</xsl:attribute>
                  </xsl:when>
                  <xsl:when test="&#xA;        (&#xA;        if&#xA;        (&#xA;          not ($cotarget_related-Request/soap12:Header/wsa:ReplyTo) or &#xA;          $cotarget_related-Request/soap12:Header/wsa:ReplyTo/wsa:Address='http://www.w3.org/2005/08/addressing/anonymous' or&#xA;          $cotarget_related-Request/soap12:Header/wsa:FaultTo/wsa:Address='http://www.w3.org/2005/08/addressing/anonymous'&#xA;        )&#xA;        then&#xA;        (&#xA;          $mytarget/soap12:Body/soap12:Fault&#xA;        )&#xA;        else fn:true()&#xA;        )&#xA;      ">
                     <xsl:attribute name="result">true</xsl:attribute>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:attribute name="result">false</xsl:attribute>
                     <xsl:element name="errmessage">
        The service requires the use of WS-Addressing with non-anonymous response EPRs. The
        response to a request with anonymous response EPRs must be the fault defined by Section
        6.4.1.8 of the "WS-Addressing 1.0 - SOAP Binding" specification. The transmitted response
        is not a SOAP Fault message.
      </xsl:element>
                     <xsl:element name="errdiagnostic">
                        <xsl:copy-of select="current()"/>
                     </xsl:element>
                  </xsl:otherwise>
               </xsl:choose>
               <wsi-rep:reporting xmlns:wsi-rep="http://www.ws-i.org/testing/2009/03/report/"
                                  truePredicateAs="passed"
                                  falsePredicateAs="failed"/>
            </xsl:element>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
   </xsl:if>
   <xsl:next-match>
      <xsl:with-param name="tgtype" select="$tgtype"/>
      <xsl:with-param name="target" select="$target"/>
      <xsl:with-param name="tempresults" select="$tempresults"/>
      <xsl:with-param name="taoutlist" select="$newtaoutlist"/>
   </xsl:next-match>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="TA" match="node()"
              priority="-1">
   <xsl:param name="tgtype"/>
   <xsl:param name="target"/>
   <xsl:param name="tempresults"/>
</xsl:template>

</xsl:stylesheet>
